<?php
namespace App\Http\Controllers\Api\Integraciones\Newsletter;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\Newsletter;

class NewsletterController extends Controller {
    public function save ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
            	$restResponse = 200;

            	$Newsletter = Newsletter::updateOrCreate(
                    ['email' => $r->email],
                    ['email' => $r->email]
                );

                $response = array(
                    "error" => false,
                    "message" => "Guardado", 
                    "data" => []
                );                
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => $e->getMessage(), 
                    "data" => []
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }
}