<?php

namespace App\Http\Controllers\Api\Integraciones\Programas\Nutricion;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\Programs;
use App\Models\Recipts;
use App\Models\ProgramRecipts;
use App\Models\CalorieRecipts;
use App\Models\IngredientRecipts;
use App\Models\StepsRecipts;
use App\Models\Ingredients;
use App\Models\KindFood;
use App\Models\CatUnits;
use App\Models\ShoppingListDates;
use App\Models\ShoppingList;
use App\Models\Clients;
use App\Models\GeneralData;
use App\Models\PlanSemanalControl;
use App\Models\IngredientReciptClient;

class NutricionController extends Controller {
    private $duration = [1 => "5-15", 2 => "15-30", 3 => "30-45", 4 => "45-60"];
    private $mes = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];
    private $dia = ["DOMINGO", "LUNES", "MARTES", "MIÉRCOLES", "JUEVES", "VIERNES", "SÁBADO"];

    private function dec2frac($dec, $unit) {
        $dec = number_format($dec, 2, '.', '');
        switch ( $unit ) {
            case "scoops":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc <= .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "latas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc <= .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "rebanadas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc <= .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "cucharadas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc > .5 && $fracc < .99 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "cucharaditas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc > .5 && $fracc < .99 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'piezas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'tazas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'piezas chicas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'piezas medianas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case "mitades":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                return $unidad + 1;
                break; 
        }
        return $dec;
    }

    public function index () {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $Programs = Programs::select( "id", "name", "slug", "able", "about", "foryou", "benefits", "image", "video" )->get()->toArray();

                foreach( $Programs as $item ) {
                    $result[] = array(
                        "id" => $item['id'], 
                        "name" => $item['name'], 
                        "slug" => $item['slug'],
                        "able" => explode("\r\n", $item['able']), 
                        "about" => explode("\r\n\r\n", $item['about']), 
                        "foryou" => explode("\r\n", str_replace("-", "", trim($item['foryou']))), 
                        "benefits" => $item['benefits'], 
                        "image" => $_ENV["URL_PATH"].$item['image'], 
                        "video" => $item['video']
                    );
                }

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => []
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getCatalogUnits() {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $CatUnits = CatUnits::select("id", "name")->get()->toArray();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $CatUnits
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => []
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getRecipt ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;
                $receta = Recipts::select("id", "name", "food_time", "flavor", "prep_time", "temp", "i_kind", "image")->where("id", $r->receta)->first();
                if ( $receta == null ) {
                    $restResponse = 500;
                    $response = array(
                        "error" => true,
                        "message" => "La receta no existe", 
                        "data" => []
                    );
                    return response()
                        ->json($response, $restResponse)
                        ->header("Access-Control-Allow-Origin", "*");
                }
                $programa = Clients::select("nutrition_plan")->where("id", $r->cliente)->first();
                $caloriaGrupo = GeneralData::select("calories")->where("i_client", $r->cliente)->first();

                if ( $caloriaGrupo['calories'] < 1100 ) {
                    $caloriaGrupo['calories'] = 1100;
                } elseif ( $caloriaGrupo['calories'] == 2100) {
                    $caloriaGrupo['calories'] = 2000;
                }

                $programa = ProgramRecipts::select("id")->where("i_recipt", $r->receta)->where("i_program", $programa['nutrition_plan'])->first();
                $calorias = CalorieRecipts::select("id")->where("i_program", $programa->id)->where("i_calorie", $caloriaGrupo['calories'])->first();
                $ingredientes = IngredientRecipts::select("i_ingredient", "portion")->where("i_calorie", $calorias->id)->get()->toArray();
                $pasos = StepsRecipts::select("step")->where("i_calorie", $calorias->id)->get()->toArray();
                $kind = KindFood::select("name")->where("id", $receta->i_kind)->first();

                $proteinas = 0;
                $carbohidratos = 0;
                $grasas = 0;

                $IngredientReciptClient = IngredientReciptClient::select("json")->where("i_client", $r->cliente)->where("i_recipt", $r->receta)->orderBy("id", "desc")->first();

                if ( $IngredientReciptClient == null ) {
                    $items = array();
                    foreach ( $ingredientes as $item ) {
                        $data = Ingredients::select( "id", "name", "portion", "unit", "protein", "fat", "carbs")->where("id", $item['i_ingredient'])->first();
                        $unidad = CatUnits::select("name")->where("id", $data['unit'])->first();
                        $proteinas = $proteinas + ($item['portion']*$data['protein']);
                        $carbohidratos = $carbohidratos + ($item['portion']*$data['carbs']);
                        $grasas = $grasas + ($item['portion']*$data['fat']);

                        // cuando es 0 solo mandar libre
                        $unidadData = "";
                        if ( $item['portion'] != "0" ) {
                            $unidadData = $item['portion'] . " ";
                        }

                        array_push( $items, array(
                            "id" => $data['id'], 
                            "ingredient" => $data['name'], 
                            "original_portion" => $item['portion'],
                            "portion" => ( $unidad['name'] == "libre" ) ? "libre" : $this->dec2frac($item['portion']*$data['portion'], $unidad['name']) . " " . $unidad['name']
                        ) );
                    }
                    $IngredientReciptClient = new IngredientReciptClient();
                    $IngredientReciptClient->i_client = $r->cliente;
                    $IngredientReciptClient->i_recipt = $r->receta;
                    $IngredientReciptClient->json = json_encode($items);
                    $IngredientReciptClient->save();
                } else {
                    $items = json_decode($IngredientReciptClient['json'], true);
                    foreach ($items as $ing ) {
                        $data = Ingredients::select( "id", "name", "portion", "unit", "protein", "fat", "carbs")->where("id", $ing['id'])->first();
                        $proteinas = $proteinas + ($ing['original_portion']*$data['protein']);
                        $carbohidratos = $carbohidratos + ($ing['original_portion']*$data['carbs']);
                        $grasas = $grasas + ($ing['original_portion']*$data['fat']);
                    }
                }

                $result = array ( 
                    "image" => $_ENV["URL_PATH"] . $receta->image,
                    "name" => strtolower($receta->name),
                    "tiempo" => strtolower($receta->food_time),
                    "flavor" => strtolower($receta->flavor),
                    "duration" => $this->duration[$receta->prep_time] . " mins",
                    "temp" => strtolower($receta->temp),
                    "kind" => strtolower($kind->name),
                    "proteins" => number_format($proteinas, 1, '.', ''). " gramos",
                    "carbs" => number_format($carbohidratos, 1, '.', ''). " gramos",
                    "fat" => number_format($grasas, 1, '.', ''). " gramos",
                    "ingredients" => array (
                        $items
                    ),
                    "pasos" => array ( 
                        $pasos
                    )
                );

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getShoppingList( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                $lun1 = date("Y-m-d", strtotime('monday this week')); 
                $mar1 = date("Y-m-d", strtotime('tuesday this week')); 
                $mie1 = date("Y-m-d", strtotime('wednesday this week')); 
                $jue1 = date("Y-m-d", strtotime('thursday this week')); 
                $vie1 = date("Y-m-d", strtotime('friday this week')); 
                $sab1 = date("Y-m-d", strtotime('saturday this week')); 
                $dom1 = date("Y-m-d", strtotime('sunday this week')); 

                $lun2 = date("Y-m-d", strtotime($lun1 . ' next monday ')); 
                $mar2 = date("Y-m-d", strtotime($mar1 . ' next tuesday')); 
                $mie2 = date("Y-m-d", strtotime($mie1 . ' next wednesday')); 
                $jue2 = date("Y-m-d", strtotime($jue1 . ' next thursday')); 
                $vie2 = date("Y-m-d", strtotime($vie1 . ' next friday')); 
                $sab2 = date("Y-m-d", strtotime($sab1 . ' next saturday')); 
                $dom2 = date("Y-m-d", strtotime($dom1 . ' next sunday')); 

                $lun3 = date("Y-m-d", strtotime($lun2 . ' next monday ')); 
                $mar3 = date("Y-m-d", strtotime($mar2 . ' next tuesday')); 
                $mie3 = date("Y-m-d", strtotime($mie2 . ' next wednesday')); 
                $jue3 = date("Y-m-d", strtotime($jue2 . ' next thursday')); 
                $vie3 = date("Y-m-d", strtotime($vie2 . ' next friday')); 
                $sab3 = date("Y-m-d", strtotime($sab2 . ' next saturday')); 
                $dom3 = date("Y-m-d", strtotime($dom2 . ' next sunday')); 

                $lun4 = date("Y-m-d", strtotime($lun3 . ' next monday ')); 
                $mar4 = date("Y-m-d", strtotime($mar3 . ' next tuesday')); 
                $mie4 = date("Y-m-d", strtotime($mie3 . ' next wednesday')); 
                $jue4 = date("Y-m-d", strtotime($jue3 . ' next thursday')); 
                $vie4 = date("Y-m-d", strtotime($vie3 . ' next friday')); 
                $sab4 = date("Y-m-d", strtotime($sab3 . ' next saturday')); 
                $dom4 = date("Y-m-d", strtotime($dom3 . ' next sunday')); 

                $lun5 = date("Y-m-d", strtotime($lun4 . ' next monday ')); 
                $mar5 = date("Y-m-d", strtotime($mar4 . ' next tuesday')); 
                $mie5 = date("Y-m-d", strtotime($mie4 . ' next wednesday')); 
                $jue5 = date("Y-m-d", strtotime($jue4 . ' next thursday')); 
                $vie5 = date("Y-m-d", strtotime($vie4 . ' next friday')); 
                $sab5 = date("Y-m-d", strtotime($sab4 . ' next saturday')); 
                $dom5 = date("Y-m-d", strtotime($dom4 . ' next sunday')); 

                /* Semana 1 */
                    $listShoppingDates1 = ShoppingListDates::select( DB::Raw( "GROUP_CONCAT(id) AS dates" ) )
                    ->whereBetween( "date_at", [$lun1, $dom1] )
                    ->where("i_client", $r->id)
                    ->groupBy("date_at")
                    ->orderBy("date_at", "DESC")
                    ->get()
                    ->toArray();

                    $dates = array();
                    foreach ( $listShoppingDates1 as $item ) {
                        array_push($dates, $item['dates']);
                    }

                    $listShoppingItems1 = ShoppingList::select("shopping_list.id", "shopping_list.item", "shopping_list.item_name", DB::Raw("SUM(shopping_list.quantity) as quantity"), "cat_unidad.name as unit", "shopping_list.status")
                    ->whereIn("i_shopping_date", $dates)
                    ->join("cat_unidad", "cat_unidad.id", "=", "shopping_list.i_unit")
                    ->whereNull("cat_unidad.deleted_at")
                    ->groupBy("shopping_list.item", "shopping_list.i_unit")
                    ->orderBy("shopping_list.item_name")
                    ->get()
                    ->toArray();

                    $listaIngredientes1 = array();
                    foreach ( $listShoppingItems1 as $item ) {
                        $create = array (
                            "id" => $item['id'], 
                            "item" => $item['item'],
                            "item_name" => $item['item_name'], 
                            "quantity" => $this->dec2frac($item['quantity'], $item['unit']), 
                            "unit" => $item['unit'], 
                            "status" => $item['status'] 
                        );
                        array_push($listaIngredientes1, $create);
                    }


                /* Semana 2 */
                    $listShoppingDates2 = ShoppingListDates::select( DB::Raw( "GROUP_CONCAT(id) AS dates" ) )
                    ->whereBetween( "date_at", [$lun2, $dom2] )
                    ->where("i_client", $r->id)
                    ->groupBy("date_at")
                    ->orderBy("date_at", "DESC")
                    ->get()
                    ->toArray();

                    $dates = array();
                    foreach ( $listShoppingDates2 as $item ) {
                        array_push($dates, $item['dates']);
                    }

                    $listShoppingItems2 = ShoppingList::select("shopping_list.id", "shopping_list.item", "shopping_list.item_name", DB::Raw("SUM(shopping_list.quantity) as quantity"), "cat_unidad.name as unit", "shopping_list.status")
                    ->whereIn("i_shopping_date", $dates)
                    ->join("cat_unidad", "cat_unidad.id", "=", "shopping_list.i_unit")
                    ->whereNull("cat_unidad.deleted_at")
                    ->groupBy("shopping_list.item", "shopping_list.i_unit")
                    ->orderBy("shopping_list.item_name")
                    ->get()
                    ->toArray();

                    $listaIngredientes2 = array();
                    foreach ( $listShoppingItems2 as $item ) {
                        $create = array (
                            "id" => $item['id'], 
                            "item" => $item['item'],
                            "item_name" => $item['item_name'], 
                            "quantity" => $this->dec2frac($item['quantity'], $item['unit']), 
                            "unit" => $item['unit'], 
                            "status" => $item['status'] 
                        );
                        array_push($listaIngredientes2, $create);
                    }

                /* Semana 3 */
                    $listShoppingDates3 = ShoppingListDates::select( DB::Raw( "GROUP_CONCAT(id) AS dates" ) )
                    ->whereBetween( "date_at", [$lun3, $dom3] )
                    ->where("i_client", $r->id)
                    ->groupBy("date_at")
                    ->orderBy("date_at", "DESC")
                    ->get()
                    ->toArray();

                    $dates = array();
                    foreach ( $listShoppingDates2 as $item ) {
                        array_push($dates, $item['dates']);
                    }

                    $listShoppingItems3 = ShoppingList::select("shopping_list.id", "shopping_list.item", "shopping_list.item_name", DB::Raw("SUM(shopping_list.quantity) as quantity"), "cat_unidad.name as unit", "shopping_list.status")
                    ->whereIn("i_shopping_date", $dates)
                    ->join("cat_unidad", "cat_unidad.id", "=", "shopping_list.i_unit")
                    ->whereNull("cat_unidad.deleted_at")
                    ->groupBy("shopping_list.item", "shopping_list.i_unit")
                    ->orderBy("shopping_list.item_name")
                    ->get()
                    ->toArray();

                    $listaIngredientes3 = array();
                    foreach ( $listShoppingItems3 as $item ) {
                        $create = array (
                            "id" => $item['id'], 
                            "item" => $item['item'],
                            "item_name" => $item['item_name'], 
                            "quantity" => $this->dec2frac($item['quantity'], $item['unit']), 
                            "unit" => $item['unit'], 
                            "status" => $item['status'] 
                        );
                        array_push($listaIngredientes3, $create);
                    }

                /* Semana 4 */
                    $listShoppingDates4 = ShoppingListDates::select( DB::Raw( "GROUP_CONCAT(id) AS dates" ) )
                    ->whereBetween( "date_at", [$lun4, $dom4] )
                    ->where("i_client", $r->id)
                    ->groupBy("date_at")
                    ->orderBy("date_at", "DESC")
                    ->get()
                    ->toArray();

                    $dates = array();
                    foreach ( $listShoppingDates4 as $item ) {
                        array_push($dates, $item['dates']);
                    }

                    $listShoppingItems4 = ShoppingList::select("shopping_list.id", "shopping_list.item", "shopping_list.item_name", DB::Raw("SUM(shopping_list.quantity) as quantity"), "cat_unidad.name as unit", "shopping_list.status")
                    ->whereIn("i_shopping_date", $dates)
                    ->join("cat_unidad", "cat_unidad.id", "=", "shopping_list.i_unit")
                    ->whereNull("cat_unidad.deleted_at")
                    ->groupBy("shopping_list.item", "shopping_list.i_unit")
                    ->orderBy("shopping_list.item_name")
                    ->get()
                    ->toArray();

                    $listaIngredientes4 = array();
                    foreach ( $listShoppingItems4 as $item ) {
                        $create = array (
                            "id" => $item['id'], 
                            "item" => $item['item'],
                            "item_name" => $item['item_name'], 
                            "quantity" => $this->dec2frac($item['quantity'], $item['unit']), 
                            "unit" => $item['unit'], 
                            "status" => $item['status'] 
                        );
                        array_push($listaIngredientes4, $create);
                    }

                /* Semana 5 */
                    $listShoppingDates5 = ShoppingListDates::select( DB::Raw( "GROUP_CONCAT(id) AS dates" ) )
                    ->whereBetween( "date_at", [$lun5, $dom5] )
                    ->where("i_client", $r->id)
                    ->groupBy("date_at")
                    ->orderBy("date_at", "DESC")
                    ->get()
                    ->toArray();

                    $dates = array();
                    foreach ( $listShoppingDates5 as $item ) {
                        array_push($dates, $item['dates']);
                    }

                    $listShoppingItems5 = ShoppingList::select("shopping_list.id", "shopping_list.item", "shopping_list.item_name", DB::Raw("SUM(shopping_list.quantity) as quantity"), "cat_unidad.name as unit", "shopping_list.status")
                    ->whereIn("i_shopping_date", $dates)
                    ->join("cat_unidad", "cat_unidad.id", "=", "shopping_list.i_unit")
                    ->whereNull("cat_unidad.deleted_at")
                    ->groupBy("shopping_list.item", "shopping_list.i_unit")
                    ->orderBy("shopping_list.item_name")
                    ->get()
                    ->toArray();

                    $listaIngredientes5 = array();
                    foreach ( $listShoppingItems5 as $item ) {
                        $create = array (
                            "id" => $item['id'], 
                            "item" => $item['item'],
                            "item_name" => $item['item_name'], 
                            "quantity" => $this->dec2frac($item['quantity'], $item['unit']), 
                            "unit" => $item['unit'], 
                            "status" => $item['status'] 
                        );
                        array_push($listaIngredientes5, $create);
                    }

                $result = array ( 
                    array( 
                        "semana" => date("d", strtotime($lun1)) . " al " . date("d", strtotime($dom1)) . " de " . $this->mes[date("n", strtotime($dom1))-1],
                        "semana_inicio" => date("d", strtotime($lun1)) . "-" . date("m", strtotime($lun1)) . "-" . date("Y", strtotime($lun1)),
                        "semana_fin" => date("d", strtotime($dom1)) . "-" . date("m", strtotime($dom1)) . "-" . date("Y", strtotime($dom1)),
                        "ingredientes" => $listaIngredientes1
                    ),
                    array( 
                        "semana" => date("d", strtotime($lun2)) . " al " . date("d", strtotime($dom2)) . " de " . $this->mes[date("n", strtotime($dom2))-1],
                        "semana_inicio" => date("d", strtotime($lun2)) . "-" . date("m", strtotime($lun2)) . "-" . date("Y", strtotime($lun2)),
                        "semana_fin" => date("d", strtotime($dom2)) . "-" . date("m", strtotime($lun2)) . "-" . date("Y", strtotime($dom2)),
                        "ingredientes" => $listaIngredientes2
                    ),
                    array( 
                        "semana" => date("d", strtotime($lun3)) . " al " . date("d", strtotime($dom3)) . " de " . $this->mes[date("n", strtotime($dom3))-1],
                        "semana_inicio" => date("d", strtotime($lun3)) . "-" . date("m", strtotime($lun3)) . "-" . date("Y", strtotime($lun3)),
                        "semana_fin" => date("d", strtotime($dom3)) . "-" . date("m", strtotime($dom3)) . "-" . date("Y", strtotime($dom3)),
                        "ingredientes" => $listaIngredientes3
                    ),
                    array( 
                        "semana" => date("d", strtotime($lun4)) . " al " . date("d", strtotime($dom4)) . " de " . $this->mes[date("n", strtotime($dom4))-1],
                        "semana_inicio" => date("d", strtotime($lun4)) . "-" . date("m", strtotime($lun4)) . "-" . date("Y", strtotime($lun4)),
                        "semana_fin" => date("d", strtotime($dom4)) . "-" . date("m", strtotime($dom4)) . "-" . date("Y", strtotime($dom4)),
                        "ingredientes" => $listaIngredientes4
                    ),
                    array( 
                        "semana" => date("d", strtotime($lun5)) . " al " . date("d", strtotime($dom5)) . " de " . $this->mes[date("n", strtotime($dom5))-1],
                        "semana_inicio" => date("d", strtotime($lun5)) . "-" . date("m", strtotime($lun5)) . "-" . date("Y", strtotime($lun5)),
                        "semana_fin" => date("d", strtotime($dom5)) . "-" . date("m", strtotime($dom5)) . "-" . date("Y", strtotime($dom5)),
                        "ingredientes" => $listaIngredientes5
                    ),
                );

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function postShoppingList( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $newDate = new ShoppingListDates();
                $newDate->i_client = $r->cliente;
                $newDate->date_at = $r->fecha;
                $newDate->save();

                $newItem = new ShoppingList();
                $newItem->i_shopping_date = $newDate->id;
                $newItem->item = $r->ingrediente;
                $newItem->item_name = $r->ingrediente_nombre;
                $newItem->quantity = $r->cantidad;
                $newItem->i_unit = $r->unidad;
                $newItem->save();

                $data = array (
                    "id" => $newItem->id, 
                    "cliente" => $r->cliente,
                    "ingrediente" => $r->ingrediente,
                    "ingrediente_nombre" => $r->ingrediente_nombre,
                    "cantidad" => $r->cantidad,
                    "unidad" => $r->unidad,
                    "fecha" => $r->fecha
                );


                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $data
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function postShoppingListStatus( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                
                $ShoppingListDates = ShoppingListDates::select( DB::Raw("GROUP_CONCAT(id) as itemDates") )
                ->where("i_client", $r->client)
                ->whereBetween("date_at", [date("Y-m-d", strtotime($r->fecha_inicio)) . " 00:00:00", date("Y-m-d", strtotime($r->fecha_fin)) . " 23:59:59"])
                ->get()
                ->toArray();

                ShoppingList::whereIn("i_shopping_date", explode(",", $ShoppingListDates[0]['itemDates']))
                ->where("item", $r->item)
                ->where("id", $r->id)
                ->update(["status" => $r->status]);

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => []
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getFechas () {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                $lun1 = date("Y-m-d", strtotime('monday this week')); 
                $mar1 = date("Y-m-d", strtotime('tuesday this week')); 
                $mie1 = date("Y-m-d", strtotime('wednesday this week')); 
                $jue1 = date("Y-m-d", strtotime('thursday this week')); 
                $vie1 = date("Y-m-d", strtotime('friday this week')); 
                $sab1 = date("Y-m-d", strtotime('saturday this week')); 
                $dom1 = date("Y-m-d", strtotime('sunday this week')); 

                $lun2 = date("Y-m-d", strtotime($lun1 . ' next monday ')); 
                $mar2 = date("Y-m-d", strtotime($mar1 . ' next tuesday')); 
                $mie2 = date("Y-m-d", strtotime($mie1 . ' next wednesday')); 
                $jue2 = date("Y-m-d", strtotime($jue1 . ' next thursday')); 
                $vie2 = date("Y-m-d", strtotime($vie1 . ' next friday')); 
                $sab2 = date("Y-m-d", strtotime($sab1 . ' next saturday')); 
                $dom2 = date("Y-m-d", strtotime($dom1 . ' next sunday')); 

                $lun3 = date("Y-m-d", strtotime($lun2 . ' next monday ')); 
                $mar3 = date("Y-m-d", strtotime($mar2 . ' next tuesday')); 
                $mie3 = date("Y-m-d", strtotime($mie2 . ' next wednesday')); 
                $jue3 = date("Y-m-d", strtotime($jue2 . ' next thursday')); 
                $vie3 = date("Y-m-d", strtotime($vie2 . ' next friday')); 
                $sab3 = date("Y-m-d", strtotime($sab2 . ' next saturday')); 
                $dom3 = date("Y-m-d", strtotime($dom2 . ' next sunday')); 

                $lun4 = date("Y-m-d", strtotime($lun3 . ' next monday ')); 
                $mar4 = date("Y-m-d", strtotime($mar3 . ' next tuesday')); 
                $mie4 = date("Y-m-d", strtotime($mie3 . ' next wednesday')); 
                $jue4 = date("Y-m-d", strtotime($jue3 . ' next thursday')); 
                $vie4 = date("Y-m-d", strtotime($vie3 . ' next friday')); 
                $sab4 = date("Y-m-d", strtotime($sab3 . ' next saturday')); 
                $dom4 = date("Y-m-d", strtotime($dom3 . ' next sunday')); 

                $lun5 = date("Y-m-d", strtotime($lun4 . ' next monday ')); 
                $mar5 = date("Y-m-d", strtotime($mar4 . ' next tuesday')); 
                $mie5 = date("Y-m-d", strtotime($mie4 . ' next wednesday')); 
                $jue5 = date("Y-m-d", strtotime($jue4 . ' next thursday')); 
                $vie5 = date("Y-m-d", strtotime($vie4 . ' next friday')); 
                $sab5 = date("Y-m-d", strtotime($sab4 . ' next saturday')); 
                $dom5 = date("Y-m-d", strtotime($dom4 . ' next sunday')); 

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function putPlan( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $cliente = Clients::where("id", $r->cliente)->update(["nutrition_plan" => $r->plan]);

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => []
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getAllRecipts2 ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                $receta = Recipts::select("id", "name", "food_time", "flavor", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image"))->get()->toArray();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $receta
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getAllRecipts ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                $cliente = Clients::select("nutrition_plan")->where("id", $r->cliente)->first();
                //dd ( $cliente["nutrition_plan"] );

                $ProgramRecipts = ProgramRecipts::select( DB::Raw("GROUP_CONCAT(i_recipt) AS i_recipt") )->where("i_program",  $cliente['nutrition_plan'])->first();

                $receta = Recipts::select("id", "name", "food_time", "flavor", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image"))->whereIn("id", explode(',', $ProgramRecipts['i_recipt']))->get()->toArray();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $receta
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getProgramNutricion( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $Programs = Programs::select( "id", "name", "able", "about", "foryou", "benefits", "image", "video" )
                ->where("id", $r->id)
                ->first();

                $result = array(
                    "id" => $Programs['id'], 
                    "name" => $Programs['name'], 
                    "able" => explode("\r\n", $Programs['able']), 
                    "about" => explode("\r\n\r\n", $Programs['about']), 
                    "foryou" => explode("\r\n", str_replace("-", "", trim($Programs['foryou']))), 
                    "benefits" => $Programs['benefits'], 
                    "image" => $_ENV["URL_PATH"].$Programs['image'], 
                    "video" => $Programs['video']
                );

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => []
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function recommendedPlan ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $GeneralData = GeneralData::select("main_goal")->where("i_client", $r->cliente)->first();
                switch( $GeneralData['main_goal'] ) {
                    case "1":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 2)->first();
                        break;
                    case "2":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 1)->first();
                        break;
                    case "3":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 5)->first();
                        break;
                    case "4":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 6)->first();
                        break;
                    case "5":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 8)->first();
                        break;
                    case "6":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 3)->first();
                        break;
                    case "7":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 7)->first();
                        break;
                    case "8":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 7)->first();
                        break;
                    case "9":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 4)->first();
                        break;
                    case "10":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 11)->first();
                        break;
                    case "11":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 9)->first();
                        break;
                    case "12":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 9)->first();
                        break;
                    case "13":
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->where("id", 10)->first();
                        break;
                    default:
                        $ProgramsMain = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->inRandomOrder()->first();
                        break;
                }

                $ProgramsRecommended = Programs::select( "id", "name", "about", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image") )->inRandomOrder()->take(4)->get()->toArray();

                $result = array(
                    "recomendado" => $ProgramsMain, 
                    "opcionales" => $ProgramsRecommended
                );

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => []
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function anotherRecipt ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $plan = Clients::select("nutrition_plan")->where("id", $r->cliente)->first();
                $generalData = GeneralData::select("calories")->where("i_client", $r->cliente)->first();
                $program = ProgramRecipts::select( DB::Raw('GROUP_CONCAT(i_recipt) as i_recipt') )->where("i_program", $plan['nutrition_plan'])->get()->toArray();
                $receta = Recipts::select("id", "food_time", "name", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', image ) as image"))->where("food_time", $r->tiempo)->whereIn("id", explode(",", $program[0]['i_recipt']) )->inRandomOrder()->first();

                $PlanSemanalControl = PlanSemanalControl::where("i_client", $r->cliente)->first();
                $result = json_decode($PlanSemanalControl['json'], true);

                $result[$r->semana]['dias'][$r->dia]['comidas']['alimento'.($r->alimento+1)]['id'] = $receta['id'];
                $result[$r->semana]['dias'][$r->dia]['comidas']['alimento'.($r->alimento+1)]['comida'] = strtoupper($receta['food_time']);
                $result[$r->semana]['dias'][$r->dia]['comidas']['alimento'.($r->alimento+1)]['nombre'] = $receta['name'];
                $result[$r->semana]['dias'][$r->dia]['comidas']['alimento'.($r->alimento+1)]['image'] = $receta['image'];

                PlanSemanalControl::where("i_client", $r->cliente)->update(["json" => $result]);

                // borrar lista de compras 
                $ShoppingListDates = ShoppingListDates::select( 'id' )->where("i_client", $r->cliente )->get()->toArray();
                foreach( $ShoppingListDates as $item ) {
                    ShoppingListDates::where("id", $item['id'])->delete();
                    ShoppingList::where("i_shopping_date", $item['id'])->delete();
                } 


                // actualizar lista de compras
                foreach ( $result as $key => $itemSemana ) {
                    if ( $key == 0 || $key == 1 || $key == 2 || $key == 3 || $key == 4 ) {
                        foreach ( $itemSemana['dias'] as $item ) {
                            $ShoppingListDates = new ShoppingListDates();
                            $ShoppingListDates->i_client = $r->cliente;
                            $ShoppingListDates->date_at = date("Y-m-d", strtotime($item["fecha_formato"]));
                            $ShoppingListDates->save();

                            foreach ( $item['comidas'] as $itemFood ) {
                                if ( $itemFood["id"] != 0 ){
                                    $programaReceta = ProgramRecipts::select("id")->where("i_recipt", $itemFood['id'])->where("i_program", $plan['nutrition_plan'])->first();

                                    if ( $programaReceta == null ) {
                                        continue;
                                    }

                                    if ( $itemFood['comida'] == "SNACK" ){
                                        $generalDataCalories = 1100;
                                    } else {
                                        $generalDataCalories = $generalData['calories'];
                                    }

                                    if ( $generalData['calories'] < 1100 ) {
                                        $generalDataCalories = 1100;
                                    } elseif ( $generalData['calories'] == 2100 ) {
                                        $generalDataCalories = 2000;
                                    }

                                    $calorieRecipts = CalorieRecipts::select("id")->where("i_program", $programaReceta['id'])->where("i_calorie", $generalDataCalories)->first();
                                    
                                    $ingredientRecipts = IngredientRecipts::select("i_ingredient", "portion")->where("i_calorie", $calorieRecipts['id'])->get()->toArray();

                                    foreach ( $ingredientRecipts as $itemIngredient ) {
                                        $ingredients = Ingredients::select("name", "portion", "unit")->where("id", $itemIngredient["i_ingredient"])->first();

                                        $ShoppingList = new ShoppingList();
                                        $ShoppingList->i_shopping_date = $ShoppingListDates->id;
                                        $ShoppingList->item = $itemIngredient["i_ingredient"];
                                        $ShoppingList->item_name = $ingredients["name"];
                                        $ShoppingList->quantity = $this->dec2frac($itemIngredient["portion"] * $ingredients["portion"], $ingredients["unit"]);
                                        $ShoppingList->i_unit = $ingredients["unit"];
                                        $ShoppingList->save();
                                    }
                                }
                            }   
                        }
                    }
                }

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $receta
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => []
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function anotherIngredient ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $plan = Clients::select("nutrition_plan")->where("id", $r->cliente)->first();

                $calorias = GeneralData::select( "calories" )->where("i_client", $r->cliente)->first();

                $programa = ProgramRecipts::select( "id" )->where("i_recipt", $r->receta)->where("i_program", $plan['nutrition_plan'])->first();

                if ( $programa == null ) {
                    $restResponse = 500;
                    $response = array(
                        "error" => true,
                        "message" => "No se pudo encontrar información, revise los valores", 
                        "data" => []
                    );
                    return response()
                        ->json($response, $restResponse)
                        ->header("Access-Control-Allow-Origin", "*");
                }

                if ( $calorias['calories'] < 1100 ) {
                    $calorias['calories'] = 1100;
                } elseif ( $calorias['calories'] == 2100) {
                    $calorias['calories'] = 2000;
                }

                $calorieGroup = CalorieRecipts::select( "id" )->where("i_program", $programa->id)->where("i_calorie", $calorias['calories'])->first();
                $ingrediente = IngredientRecipts::select("i_ingredient", "portion")->where("i_calorie", $calorieGroup['id'])->where("i_ingredient", $r->ingrediente)->first();

                if ( $ingrediente == null ) {
                    $IngredientReciptClient = IngredientReciptClient::select("json")->where("i_client", $r->cliente)->orderBy("id", "desc")->first();
                    $arrayIngre = json_decode($IngredientReciptClient['json'], true);
                    
                    foreach ($arrayIngre as $item ) {
                        if ( $item['id'] == $r->ingrediente ) {
                            $ingredienteInfo = Ingredients::select('ingredient')->where("id", $item['id'])->first();
                            $ingredienteRand = Ingredients::select("id", "name", "portion", "unit")->where("ingredient", $ingredienteInfo['ingredient'])->inRandomOrder()->first();
                            $unidad = CatUnits::select("name")->where("id", $ingredienteRand['unit'])->first();


                            $unidadData = "";
                            if ( $item['original_portion'] != "0" ) {
                                $unidadData = $item['original_portion'] . " ";
                            }
                            $ingredienteResult = array(
                                "id" => $ingredienteRand['id'], 
                                "ingredient" => $ingredienteRand['name'], 
                                "original_portion" => $item['original_portion'],
                                "portion" => ( $unidad['name'] == "libre" ) ? "libre" : $this->dec2frac($item['original_portion']*$ingredienteRand['portion'], $unidad['name']) . " " . $unidad['name']
                            );

                            $IngredientReciptClient = IngredientReciptClient::select("json")->where("i_client", $r->cliente)->where("i_recipt", $r->receta)->orderBy("id", "desc")->first();
                            $ingredientsArray = json_decode($IngredientReciptClient['json'], true) ;

                            foreach ( $ingredientsArray as $key => $itemArray ) {
                                if ( $itemArray['id'] == $r->ingrediente ) {
                                    $position = $key;
                                }
                            }

                            if ( !isset($position)) {
                                $restResponse = 500;
                                $response = array(
                                    "error" => true,
                                    "message" => "No encontré el ingrediente", 
                                    "data" => []
                                );
                                return response()
                                ->json($response, $restResponse)
                                ->header("Access-Control-Allow-Origin", "*");
                            } else {
                                $ingredientsArray[$position]['id'] = $ingredienteResult['id']; 
                                $ingredientsArray[$position]['ingredient'] = $ingredienteResult['ingredient']; 
                                $ingredientsArray[$position]['original_portion'] = $ingredienteResult['original_portion']; 
                                $ingredientsArray[$position]['portion'] = $ingredienteResult['portion']; 
                            }

                            IngredientReciptClient::where("i_client", $r->cliente)->where("i_recipt", $r->receta)->update(["json" => json_encode($ingredientsArray)]);

                            $restResponse = 200;
                            $response = array(
                                "error" => false,
                                "message" => "Consulta exitosa", 
                                "data" => $ingredienteResult
                            );
                            $bandera = true;
                            break;
                        } else {
                            $bandera = false;
                        }
                    }

                    if ( !$bandera ) {
                        $restResponse = 500;
                        $response = array(
                            "error" => true,
                            "message" => "Ocurrió un error al buscar otro ingrediente", 
                            "data" => []
                        );
                    }
                } else {
                    $ingredienteInfo = Ingredients::select('ingredient')->where("id", $ingrediente['i_ingredient'])->first();
                    $ingredienteRand = Ingredients::select("id", "name", "portion", "unit")->where("ingredient", $ingredienteInfo['ingredient'])->inRandomOrder()->first();
                    $unidad = CatUnits::select("name")->where("id", $ingredienteRand['unit'])->first();

                    $unidadData = "";
                    if ( $ingrediente['portion'] != "0" ) {
                        $unidadData = $ingrediente['portion'] . " ";
                    }
                    
                    $ingredienteResult = array(
                        "id" => $ingredienteRand['id'], 
                        "ingredient" => $ingredienteRand['name'], 
                        "original_portion" => $ingrediente['portion'],
                        "portion" => ( $unidad['name'] == "libre" ) ? "libre" : $this->dec2frac($ingrediente['portion']*$ingredienteRand['portion'], $unidad['name']) . " " . $unidad['name']
                    );

                    $IngredientReciptClient = IngredientReciptClient::select("json")->where("i_client", $r->cliente)->where("i_recipt", $r->receta)->orderBy("id", "desc")->first();
                    $ingredientsArray = json_decode($IngredientReciptClient['json'], true) ;

                    foreach ( $ingredientsArray as $key => $item ) {
                        if ( $item['id'] == $r->ingrediente ) {
                            $position = $key;
                            break;
                        }
                    }

                    if ( !isset($position)) {
                        $restResponse = 500;
                        $response = array(
                            "error" => true,
                            "message" => "No encontré el ingrediente", 
                            "data" => []
                        );
                        return response()
                        ->json($response, $restResponse)
                        ->header("Access-Control-Allow-Origin", "*");
                    } else {
                        $ingredientsArray[$position]['id'] = $ingredienteResult['id']; 
                        $ingredientsArray[$position]['ingredient'] = $ingredienteResult['ingredient']; 
                        $ingredientsArray[$position]['original_portion'] = $ingredienteResult['original_portion']; 
                        $ingredientsArray[$position]['portion'] = $ingredienteResult['portion']; 
                    }

                    IngredientReciptClient::where("i_client", $r->cliente)->where("i_recipt", $r->receta)->update(["json" => json_encode($ingredientsArray)]);

                    $restResponse = 200;
                    $response = array(
                        "error" => false,
                        "message" => "Consulta exitosa", 
                        "data" => $ingredienteResult
                    );
                }

                /**/
                $PlanSemanalControl = PlanSemanalControl::select("json")->where("i_client", $r->cliente)->orderBy("id", "desc")->first();
                $result = json_decode($PlanSemanalControl['json'], true);
                
                // borrar lista de compras 
                $ShoppingListDates = ShoppingListDates::select( 'id' )->where("i_client", $r->cliente )->get()->toArray();
                foreach( $ShoppingListDates as $item ) {
                    ShoppingListDates::where("id", $item['id'])->delete();
                    ShoppingList::where("i_shopping_date", $item['id'])->delete();
                } 

                // actualizar lista de compras
                foreach ( $result as $key => $itemSemana ) {
                    if ( $key == 0 || $key == 1 || $key == 2 || $key == 3 || $key == 4 ) {
                        foreach ( $itemSemana['dias'] as $item ) {
                            $ShoppingListDates = new ShoppingListDates();
                            $ShoppingListDates->i_client = $r->cliente;
                            $ShoppingListDates->date_at = date("Y-m-d", strtotime($item["fecha_formato"]));
                            $ShoppingListDates->save();


                            foreach ( $item['comidas'] as $itemFood ) {
                                if ( $itemFood["id"] != 0 ){
                                    $programaReceta = ProgramRecipts::select("id")->where("i_recipt", $itemFood['id'])->where("i_program", $plan['nutrition_plan'])->first();

                                    if ( $itemFood['comida'] == "SNACK" ){
                                        $calorias['calories'] = 1100;
                                    } 

                                    if ( $calorias['calories'] < 1100 ) {
                                        $calorias['calories'] = 1100;
                                    } elseif ( $calorias['calories'] == 2100 ) {
                                        $calorias['calories'] = 2000;
                                    }

                                    $calorieRecipts = CalorieRecipts::select("id")->where("i_program", $programaReceta['id'])->where("i_calorie", $calorias['calories'])->first();

                                    // Buscar en ingredient_recipt_client la receta de item['id']
                                    // si existe buscar y reemplazar el id de ingrediente ingresado
                                    // si no existe hacer el flujo siguiente
                                    
                                    $IngredientReciptClient = IngredientReciptClient::select("json")->where("i_recipt", $itemFood['id'])->first();

                                    if ( $IngredientReciptClient == null ) { 
                                        $ingredientRecipts = IngredientRecipts::select("i_ingredient", "portion")->where("i_calorie", $calorieRecipts['id'])->get()->toArray();
                                        foreach ( $ingredientRecipts as $itemIngredient ) {
                                            $ingredients = Ingredients::select("name", "portion", "unit")->where("id", $itemIngredient["i_ingredient"])->first();

                                            $ShoppingList = new ShoppingList();
                                            $ShoppingList->i_shopping_date = $ShoppingListDates->id;
                                            $ShoppingList->item = $itemIngredient["i_ingredient"];
                                            $ShoppingList->item_name = $ingredients["name"];
                                            $ShoppingList->quantity = $this->dec2frac($itemIngredient["portion"]* $ingredients["portion"], $ingredients["unit"]);
                                            $ShoppingList->i_unit = $ingredients["unit"];
                                            $ShoppingList->save();
                                        }
                                    } else {
                                        $arrayIngredientesCliente = json_decode($IngredientReciptClient['json'], true);
                                        foreach ( $arrayIngredientesCliente as $itemIngredient ) {
                                            $ingredients = Ingredients::select("name", "portion", "unit")->where("id", $itemIngredient["id"])->first();

                                            $ShoppingList = new ShoppingList();
                                            $ShoppingList->i_shopping_date = $ShoppingListDates->id;
                                            $ShoppingList->item = $itemIngredient["id"];
                                            $ShoppingList->item_name = $itemIngredient["ingredient"];
                                            $ShoppingList->quantity = $this->dec2frac($itemIngredient["original_portion"] * $ingredients["portion"], $ingredients["unit"]);
                                            $ShoppingList->i_unit = $ingredients["unit"];
                                            $ShoppingList->save();
                                        }
                                    }
                                }
                            }   
                        }
                    }
                }
                /**/
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getOriginalRecipt ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;
                $receta = Recipts::select("id", "name", "food_time", "flavor", "prep_time", "temp", "i_kind", "image")->where("id", $r->receta)->first();
                if ( $receta == null ) {
                    $restResponse = 500;
                    $response = array(
                        "error" => true,
                        "message" => "La receta no existe", 
                        "data" => []
                    );
                    return response()
                        ->json($response, $restResponse)
                        ->header("Access-Control-Allow-Origin", "*");
                }
                $programa = Clients::select("nutrition_plan")->where("id", $r->cliente)->first();
                $caloriaGrupo = GeneralData::select("calories")->where("i_client", $r->cliente)->first();

                if ( $caloriaGrupo['calories'] < 1100 ) {
                    $caloriaGrupo['calories'] = 1100;
                } elseif ( $caloriaGrupo['calories'] == 2100) {
                    $caloriaGrupo['calories'] = 2000;
                }

                $programa = ProgramRecipts::select("id")->where("i_recipt", $r->receta)->where("i_program", $programa['nutrition_plan'])->first();
                $calorias = CalorieRecipts::select("id")->where("i_program", $programa->id)->where("i_calorie", $caloriaGrupo['calories'])->first();
                $ingredientes = IngredientRecipts::select("i_ingredient", "portion")->where("i_calorie", $calorias->id)->get()->toArray();
                $pasos = StepsRecipts::select("step")->where("i_calorie", $calorias->id)->get()->toArray();
                $kind = KindFood::select("name")->where("id", $receta->i_kind)->first();

                $proteinas = 0;
                $carbohidratos = 0;
                $grasas = 0;
 
                $items = array();
                foreach ( $ingredientes as $item ) {
                    $data = Ingredients::select( "id", "name", "portion", "unit", "protein", "fat", "carbs")->where("id", $item['i_ingredient'])->first();
                    $unidad = CatUnits::select("name")->where("id", $data['unit'])->first();
                    $proteinas = $proteinas + ($item['portion']*$data['protein']);
                    $carbohidratos = $carbohidratos + ($item['portion']*$data['carbs']);
                    $grasas = $grasas + ($item['portion']*$data['fat']);

                    $unidadData = "";
                    if ( $item['portion'] != "0" ) {
                        $unidadData = $item['portion'] . " ";
                    }
                    array_push( $items, array(
                        "id" => $data['id'], 
                        "ingredient" => $data['name'], 
                        "original_portion" => $item['portion'],
                        "portion" => ( $unidad['name'] == "libre" ) ? "libre" : $this->dec2frac($item['portion']*$data['portion'], $unidad['name']) . " " . $unidad['name']
                    ) );
                }
                /*
                $IngredientReciptClient = new IngredientReciptClient();
                $IngredientReciptClient->i_client = $r->cliente;
                $IngredientReciptClient->i_recipt = $r->receta;
                $IngredientReciptClient->json = json_encode($items);
                $IngredientReciptClient->save();
                */

                $result = array ( 
                    "image" => $_ENV["URL_PATH"] . $receta->image,
                    "name" => strtolower($receta->name),
                    "tiempo" => strtolower($receta->food_time),
                    "flavor" => strtolower($receta->flavor),
                    "duration" => $this->duration[$receta->prep_time] . " mins",
                    "temp" => strtolower($receta->temp),
                    "kind" => strtolower($kind->name),
                    "proteins" => number_format($proteinas, 1, '.', ''). " gramos",
                    "carbs" => number_format($carbohidratos, 1, '.', ''). " gramos",
                    "fat" => number_format($grasas, 1, '.', ''). " gramos",
                    "ingredients" => array (
                        $items
                    ),
                    "pasos" => array ( 
                        $pasos
                    )
                );

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }
}