<?php

namespace App\Http\Controllers\Api\Integraciones\Registro;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\Clients;
use App\Models\GeneralData;
use App\Models\HealthyPregnancy;
use App\Models\HealthyPostpartum;
use App\Models\HealthyLactation;
use App\Models\MainGoal;
use App\Models\HormonalDisorders;
use App\Models\GoalWeight;
use App\Models\PhysicalActivity;
use App\Models\Suscriptions;
use App\Models\Ingredients;

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;


class RegistroController extends Controller {
    public function registrar ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                $addClient = new Clients();
                $addClient->fullname = $r->name;
                $addClient->email = $r->email;
                $addClient->phone = $r->phone;
                $addClient->country = $r->country;
                $addClient->password = bcrypt($r->pass);
                $addClient->suscription_plan = $r->suscription;
                $addClient->save();

                $view = view('emails/bienvenida')->render();

                $mail = new PHPMailer(true);
                $mail->Host = "smtp.gmail.com";
                $mail->Port       = 587;
                $mail->SMTPSecure = '';
                $mail->SMTPAuth   = true;
                $mail->IsHTML(true);
                $mail->CharSet = 'UTF-8';

                $mail->Username = "hola@glowmeapp.com";
                $mail->Password = "ckqbyhujrpdesrrk";
                $mail->SetFrom('hola@glowmeapp.com', 'Hola GlowMe');
                $mail->addReplyTo('hola@glowmeapp.com', 'Hola GlowMe');

                $mail->Subject = "GlowMe Bienvenida";
                $mail->Body = $view;
                $mail->AddAddress($r->email, "{$r->name}");
                $mail->addBCC('mauricio.salinas@metodika.mx', 'Leads');
                $mail->addBCC('leads@metodika.mx', 'Leads');
                $mail->addBCC('carlos.betancourt@metodika.mx', 'Carlos');
                $mail->addBCC('clara.viera@metodika.mx', 'Clara');

                $mail->Send();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => ["cliente_id" => $addClient->id]
                );
            } catch (QueryException $e) {
                if ( $e->getCode() == 23000 ) {
                    $restResponse = 422;
                    $response = array(
                        "error" => true,
                        "message" => "Valide su correo electrónico",
                        "errors" => array(
                            "correo" => array(
                                array("La cuenta de correo ingresada ya existe")
                            )
                        ), 
                        "data" => $e->getMessage()
                    );
                } else {
                    $restResponse = 422;
                    $response = array(
                        "error" => true,
                        "message" => "No pudimos registrar la cuenta", 
                        "data" => $e->getMessage()
                    );
                }
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getPlanes () {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                $Suscriptions = Suscriptions::select("id", "name", "desc", "cost", "plan", "save", "stripe_price", "paypal_plan")->get()->toArray();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $Suscriptions
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function cuestionario( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                /* Unidades 
                1 kg
                2 lb
                3 cm
                4 in
                */

                $GeneralData = new GeneralData();
                $GeneralData->i_client = $r->client;
                $GeneralData->birth_date = $r->birth;
                $GeneralData->weight = $r->weight;
                $GeneralData->weight_unit = $r->weight_unit;
                $GeneralData->height = $r->height;
                $GeneralData->height_unit = $r->height_unit;
                $GeneralData->waist = $r->waist;
                $GeneralData->waist_unit = $r->waist_unit;
                $GeneralData->hip = $r->hip;
                $GeneralData->hip_unit = $r->hip_unit;
                $GeneralData->main_goal = $r->main_goal;
                $GeneralData->weight_goal = $r->weight_goal;
                $GeneralData->physical_activity = $r->physical_activity;
                $GeneralData->hormonal_disorders = json_encode($r->hormonal_disorders);
                $GeneralData->exceptions = json_encode($r->exceptions);
                $GeneralData->save();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => []
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function embarazo( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                /* Unidades 
                1 kg
                2 lb
                */

                $HealthyPregnancy = new HealthyPregnancy();
                $HealthyPregnancy->i_client = $r->client;
                $HealthyPregnancy->weeks = $r->weeks;
                $HealthyPregnancy->weight = $r->weight;
                $HealthyPregnancy->weight_unit = $r->weight_unit;
                $HealthyPregnancy->babys = $r->babies;
                $HealthyPregnancy->save();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => []
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function lactancia( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                /* Unidades 
                1 kg
                2 lb

                1 Exclusiva
                2 Mixta
                */

                $HealthyLactation = new HealthyLactation();
                $HealthyLactation->i_client = $r->client;
                $HealthyLactation->weeks = $r->weeks;
                $HealthyLactation->weight = $r->weight;
                $HealthyLactation->weight_unit = $r->weight_unit;
                $HealthyLactation->lactation = $r->lactation;
                $HealthyLactation->save();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => []
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function posparto( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                /* Unidades 
                1 kg
                2 lb

                1 Exclusiva
                2 Mixta
                */

                $HealthyPostpartum = new HealthyPostpartum();
                $HealthyPostpartum->i_client = $r->client;
                $HealthyPostpartum->weeks = $r->weeks;
                $HealthyPostpartum->weight = $r->weight;
                $HealthyPostpartum->weight_unit = $r->weight_unit;
                $HealthyPostpartum->lactation = $r->lactation;
                $HealthyPostpartum->save();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => []
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        } 
    }

    public function mainGoal () {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;
                $MainGoal = MainGoal::get();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $MainGoal
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function goalWeight () {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;
                $GoalWeight = GoalWeight::get();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $GoalWeight
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function hormonalDisorders() {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;
                $HormonalDisorders = HormonalDisorders::get();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $HormonalDisorders
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function physicalActivity () {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;
                $PhysicalActivity = PhysicalActivity::get();

                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $PhysicalActivity
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "No se pudo encontrar información", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function putPlan( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $data = Clients::select("fullname", "email", "suscription_plan", "suscription_id", "source_active", "paypal_source")->where("id", $r->cliente)->first();
                $old = $data['suscription_plan'];
                $new = $r->plan;

                $oldData = Suscriptions::select("name", "cost", DB::Raw("
                    CASE
                        WHEN id = 1 THEN cost/1
                        WHEN id = 2 THEN cost/3
                        WHEN id = 3 THEN cost/6
                    END
                as plan"))->where("id", $old)->first();
                $newData = Suscriptions::select("name", "cost", DB::Raw("
                    CASE
                        WHEN id = 1 THEN cost/1
                        WHEN id = 2 THEN cost/3
                        WHEN id = 3 THEN cost/6
                    END
                as plan"))->where("id", $new)->first();

                $cliente = Clients::where("id", $r->cliente)->update(["suscription_plan" => $r->plan]);

                /***/
                if ( $data['source_active'] == 'stripe') {
                    $stripe = new \Stripe\StripeClient($_ENV['STRIPE_SECRET']);

                    $createReponse = $stripe->subscriptions->retrieve(
                        $data['suscription_id'],
                        []
                    );
                } else {
                    // Generar Token
                    $params = '{
                        "grant_type": "client_credentials"
                    }';

                    $headers = array ( 'Accept: application/json', 'Accept-Language: en_US', 'Accept-Language: en_US' );

                    $soap_do = curl_init();
                    curl_setopt( $soap_do, CURLOPT_URL, $_ENV['API_PAYPAL_URL'].'/oauth2/token' );
                    curl_setopt( $soap_do, CURLOPT_RETURNTRANSFER, true );
                    curl_setopt( $soap_do, CURLOPT_POST, 1);
                    curl_setopt( $soap_do, CURLOPT_POSTFIELDS, "grant_type=client_credentials");
                    curl_setopt( $soap_do, CURLOPT_USERPWD, 'Ac6hbSHwiUwMXgbhn0YrBtzQ0EsfBBtRu4zwmLG9cP-g-K7mhFVGVkZvSytiE0UwahDVTHiuIrHQoY2E' . ':' . 'EDMfJryobI5gqUVb5xw7D7lUH-_Yj0O9MXxlChe15NtyVP5GkK74GdW8sjWC92gn7sR79lpE9w2fIqa5');

                    curl_setopt( $soap_do, CURLOPT_HTTPHEADER, $headers );
                    $result = curl_exec($soap_do);
                    $Reponse = json_decode($result, true);

                    $Token = $Reponse['access_token'];

                    //

                    $ch = curl_init();

                    curl_setopt($ch, CURLOPT_URL, $_ENV['API_PAYPAL_URL'].'/billing/subscriptions/'.$data['paypal_source']);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');


                    $headers = array ( 'Authorization: Bearer ' . $Token, 'Content-Type: application/json' );
                    $headers[] = 'Content-Type: application/json';
                    $headers[] = 'Accept: application/json';
                    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                    $result = curl_exec($ch);
                    $result = json_decode($result, true);

                    $createReponse['current_period_end'] = strtotime($result['billing_info']['next_billing_time']);

                    curl_close($ch);
                }
                /***/

                $view = view('emails/cambio-plan', [ 'name' => $data['fullname'], 'oldData' => $oldData, 'newData' => $newData, 'next' => date("d / m / Y", $createReponse['current_period_end']) ])->render();

                $mail = new PHPMailer(true);
                $mail->Host = "smtp.gmail.com";
                $mail->Port       = 587;
                $mail->SMTPSecure = '';
                $mail->SMTPAuth   = true;
                $mail->IsHTML(true);
                $mail->CharSet = 'UTF-8';

                $mail->Username = "hola@glowmeapp.com";
                $mail->Password = "ckqbyhujrpdesrrk";
                $mail->SetFrom('hola@glowmeapp.com', 'Hola GlowMe');
                $mail->addReplyTo('hola@glowmeapp.com', 'Hola GlowMe');

                $mail->Subject = "GlowMe Cambio de Plan";
                $mail->Body = $view; 
                $mail->AddAddress($data['email'], "{$data['fullname']}");
                $mail->addBCC('mauricio.salinas@metodika.mx', 'Leads');
                $mail->addBCC('leads@metodika.mx', 'Leads');
                $mail->addBCC('carlos.betancourt@metodika.mx', 'Carlos');
                $mail->addBCC('clara.viera@metodika.mx', 'Clara');

                $mail->Send(); 

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => []
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getIngredientes () {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $ingredientes = Ingredients::select("id", "name")->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $ingredientes
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }
}
