<?php
// https://developer.paypal.com/docs/subscriptions/integrate/
// https://developer.paypal.com/dashboard/dashboard/sandbox
// https://developer.paypal.com/docs/subscriptions/integrate/
//https://developer.paypal.com/docs/api/subscriptions/v1/#subscriptions_create
namespace App\Http\Controllers\paypal;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\UserProfiles;
use App\Models\Users;
use App\Models\Clients;
use App\Models\Charges;

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

class PaypalController extends Controller {
	protected $API_URL = "https://api-m.sandbox.paypal.com/v1";

	public function index() {
		return view('paypal');
	}

    public function create( ) {
    	// Generar Token
		$params = '{
			"grant_type": "client_credentials"
		}';

		$headers = array ( 'Accept: application/json', 'Accept-Language: en_US', 'Accept-Language: en_US' );

        $soap_do = curl_init();
        curl_setopt( $soap_do, CURLOPT_URL, $_ENV['API_PAYPAL_URL'].'/oauth2/token' );
        curl_setopt( $soap_do, CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $soap_do, CURLOPT_POST, 1);
        curl_setopt( $soap_do, CURLOPT_POSTFIELDS, "grant_type=client_credentials");
        curl_setopt( $soap_do, CURLOPT_USERPWD, 'Ac6hbSHwiUwMXgbhn0YrBtzQ0EsfBBtRu4zwmLG9cP-g-K7mhFVGVkZvSytiE0UwahDVTHiuIrHQoY2E' . ':' . 'EDMfJryobI5gqUVb5xw7D7lUH-_Yj0O9MXxlChe15NtyVP5GkK74GdW8sjWC92gn7sR79lpE9w2fIqa5');

        curl_setopt( $soap_do, CURLOPT_HTTPHEADER, $headers );
        $result = curl_exec($soap_do);
        $Reponse = json_decode($result, true);

        $Token = $Reponse['access_token'];

        // Generar Suscripción
		$params = '{
			"product_id": "PROD-9VU21748WP413880H",
      		"name": "Plan Semestral",
      		"description": "Nuestro Plan Semestral de Nutrición Saludable es la clave para lograr tus objetivos de bienestar y alimentación equilibrada.",
      		"billing_cycles": [
        		{
	          		"frequency": {
    	        		"interval_unit": "MONTH",
            			"interval_count": 6
          			},
          			"tenure_type": "REGULAR",
          			"sequence": 1,
          			"total_cycles": 12,
          			"pricing_scheme": {
			            "fixed_price": {
			             	"value": "3355",
			            	"currency_code": "MXN"
			            }
		          	}
        		}
      		],
      		"payment_preferences": {
        		"auto_bill_outstanding": true,
        		"setup_fee": {
          			"value": "0",
          			"currency_code": "MXN"
        		}
      		}
    	}';

		$headers = array ( 'Authorization: Bearer ' . $Token, 
			'Content-Type: application/json' );

        $soap_do = curl_init();
        curl_setopt( $soap_do, CURLOPT_URL, $_ENV['API_PAYPAL_URL'].'/billing/plans' );
        curl_setopt( $soap_do, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt( $soap_do, CURLOPT_POST, 1);
        curl_setopt( $soap_do, CURLOPT_POSTFIELDS, $params );
        curl_setopt( $soap_do, CURLOPT_HTTPHEADER, $headers );
        $result = curl_exec($soap_do);
        $CreateProducto = json_decode($result, true);

        return response()->json([ 
            'error' => false, 
            'message' => 'success', 
            'data' => $CreateProducto], 200);
    }

    public function paypalWebhook () {
    	$body = @file_get_contents('php://input');
		$data = json_decode($body);

		if ( $data->event_type == "BILLING.SUBSCRIPTION.UPDATED" ) {
			$amount = 0;
			foreach ( $data->resource->plan->payment_definitions as $item ) {
				if ( $item->type == "REGULAR" ) {
					$amount = $item->amount->value;
				}
			}
			$Client = Clients::select("id", "suscription_plan")->where("paypal_source", $data->resource->id)->first();

			if ( $Client != null ) {
				Clients::where("stripe_source", $customer)->update(["last_charge" => $date, "status" => 1]);

				$Charges = new Charges();
	            $Charges->i_client = $Client['id'];
	            $Charges->i_subscription = $Client['suscription_plan'];
	            $Charges->vc_amount = $amount;
	            $Charges->status = "Success";
	            $Charges->save();

	            $Suscriptions = Suscriptions::select("name", "cost", DB::Raw("
                    CASE
                        WHEN id = 1 THEN cost/1
                        WHEN id = 2 THEN cost/3
                        WHEN id = 3 THEN cost/6
                    END
                as plan"))->where("id", $Client['suscription_plan'])->first();

                $date_future = strtotime('+30 day', strtotime(date("Y-m-d")));

                $view = view('emails/pay-success', ["name" => $Client['fullname'], "data" => array("name" => $Suscriptions['name'], "cost" => $Suscriptions['cost'], "plan" => $Suscriptions['plan']), "next" => date("d", $date_future) . " / " . date("m", $date_future) . " / " . date("Y", $date_future) ])->render();

                $mail = new PHPMailer(true);
                $mail->Host = "smtp.gmail.com";
                $mail->Port       = 587;
                $mail->SMTPSecure = '';
                $mail->SMTPAuth   = true;
                $mail->IsHTML(true);
                $mail->CharSet = 'UTF-8';

                $mail->Username = "hola@glowmeapp.com";
                $mail->Password = "ckqbyhujrpdesrrk";
                $mail->SetFrom('hola@glowmeapp.com', 'Hola GlowMe');
                $mail->addReplyTo('hola@glowmeapp.com', 'Hola GlowMe');

                $mail->Subject = "GlowMe Renovación de Plan";
                $mail->Body = $view; 
                $mail->AddAddress($Client['email'], "{$Client['fullname']}");
                $mail->addBCC('mauricio.salinas@metodika.mx', 'Leads');
                $mail->addBCC('leads@metodika.mx', 'Leads');
                $mail->addBCC('carlos.betancourt@metodika.mx', 'Carlos');
                $mail->addBCC('clara.viera@metodika.mx', 'Clara');

                $mail->Send();
	        }
		} elseif ( $data->event_type == "BILLING.SUBSCRIPTION.PAYMENT.FAILED" ) {
			$amount = 0;
			$Client = Clients::select("id", "suscription_plan")->where("paypal_source", $data->resource->id)->first();

			if ( $Client != null ) {
				Clients::where("stripe_source", $customer)->update(["suscription_cancel_at" => $date, "status" => -2]);

				$Charges = new Charges();
	            $Charges->i_client = $Client['id'];
	            $Charges->i_subscription = $Client['suscription_plan'];
	            $Charges->vc_amount = $amount;
	            $Charges->status = "Failed";
	            $Charges->save();

	            $view = view('emails/pay-fail', ["name" => $Client['fullname']])->render();

                $mail = new PHPMailer(true);
                $mail->Host = "smtp.gmail.com";
                $mail->Port       = 587;
                $mail->SMTPSecure = '';
                $mail->SMTPAuth   = true;
                $mail->IsHTML(true);
                $mail->CharSet = 'UTF-8';

                $mail->Username = "hola@glowmeapp.com";
                $mail->Password = "ckqbyhujrpdesrrk";
                $mail->SetFrom('hola@glowmeapp.com', 'Hola GlowMe');
                $mail->addReplyTo('hola@glowmeapp.com', 'Hola GlowMe');

                $mail->Subject = "GlowMe Cobro Fallido";
                $mail->Body = $view; 
                $mail->AddAddress($Client['email'], "{$Client['fullname']}");
                $mail->addBCC('mauricio.salinas@metodika.mx', 'Leads');
                $mail->addBCC('leads@metodika.mx', 'Leads');
                $mail->addBCC('carlos.betancourt@metodika.mx', 'Carlos');
                $mail->addBCC('clara.viera@metodika.mx', 'Clara');

                $mail->Send();
	        }
		}
    	
    	http_response_code(200);
    }
}


/*
	Producto Menusal: PROD-9VU21748WP413880H
	Plan Menusal: P-4PG88712GD033013UMUSEMAA

	Producto Trimestral: PROD-43608453870309724
	Plan Trimestral: P-54975410NU1791644MUSEMOA

	Producto Semestral: PROD-0DS53540HM636451F
	Plan Semestral: P-14E0213317376642KMUSEM3A
*/