<!DOCTYPE html>
<html lang="es" dir="ltr" xmlns:v="urn:schemas-microsoft-com:vml" xmlns:o="urn:schemas-microsoft-com:office:office">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>GlowMe | Cambio de Plan</title>
    <style>
        html,*, *:before, *:after { 
            box-sizing: border-box;
        }
        table,
        table tr,
        table tr td,
        thead, tbody, tfoot {
            width:100%;
            display: block;
            text-align:center; 
            font-size: 14px;
        }
        @media only screen and (max-width: 576px) {
    
            .txt {
                font-size: 12px!important;
            }
            td.title {
                font-size: 22px!important;
            }
            .br {
                width:unset!important;
                display: inline-block!important;
            }
        }
        @media all {
            td.title {
                font-size: 22px!important;
            }
            .txt {
                font-size: 16px!important;
            }
            .br {
                width:100%!important;
                display: block!important;
            }
        }
    </style>
</head>
<body style="background-color:#fff; line-height: 1.2; margin: 0; padding: 0; -ms-text-size-adjust: 100%; -webkit-text-size-adjust: 100%; font-family:arial;">
    <table style="width:100%; border:0;" cellpadding="0" cellspacing="0">
        <thead style="width:100%;">
            <tr>
                <td style="width:100%; height:24px; display:block; background-color:#ff71b8;"></td>
            </tr>
            <tr>
                <td style="width:100%; height:40px; display:block; background-color:#fff;"></td>
            </tr>
            <tr>
                <td style="text-align:center; padding: 40px 12px; 24px 12px;">
                    <img src="http://glowmeapp.com/assets/img/header-logo.png" alt="GlowMe" style="width:200px; height:auto; object-fit:cover;">
                </td>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td class="title" style="text-align:center; font-weight:600; padding: 40px 12px 12px; line-height:1.2;">
                    <div style="font-size:30px;">Editaste tu suscripción</div>
                </td>
            </tr>

            <tr style="width: 100%; display:block; text-align:center;">
                <td class="txt" style="width: 100%; display:block; text-align:center; font-weight: 400; padding: 24px 12px; line-height:1.2;">
                    <div class="br" style="font-size: 16px;">Hola, {{ $name }}. <br />
                        Recientemente realizaste un ajuste en tu suscripción de GlowMe.<br />A continuación te mostramos los detalles.
                    </div>
                </td>
            </tr>

            <tr style="width: 100%; margin-bottom: 20px; opacity: 0.5;">
                <td style="background-color: #F8F6FB; padding: 10px;">
                    <div style="display: flex; width: 100%;">
                        <div style="width: 25%;">
                            <img src="http://glowmeapp.com/assets/img/landing/sticker04.png" alt="Sticker" width="45px" style="margin-top: 20px;" /></div>
                        <div style="width: 50%; text-align: left;">
                            <p class="br" style="font-size: 16px; margin: 0px; margin-top: 20px;">{{ $name }}<br />
                            <span style="color: #ff71b8; font-weight: bold; font-size: 24px;">{{ $oldData['name'] }}</span></p>
                        </div>
                        <div style="width: 25%">
                            <p style="font-size: 30px; font-weight: bold; margin-bottom: 0px;">${{ $oldData['cost'] }}</p>
                            <p style="font-size: 24px; margin-top: 0px;">${{ number_format($oldData['plan'], 0, '', '') }} / Mes</p>
                        </div>
                    </div>
                    
                </td>
            </tr>

            <tr style="width: 100%; margin-bottom: 20px;">
                <td>
                    <p style="font-size: 60px; margin: 0px; font-weight: bold; color: #ff71b8;">&#8595; </p>                   
                </td>
            </tr>

            <tr style="width: 100%;">
                <td style="background-color: #F8F6FB; padding: 10px;">
                    <div style="display: flex; width: 100%;">
                        <div style="width: 25%;">
                            <img src="http://glowmeapp.com/assets/img/landing/sticker04.png" alt="Sticker" width="45px" style="margin-top: 20px;" /></div>
                        <div style="width: 50%; text-align: left;">
                            <p class="br" style="font-size: 16px; margin: 0px; margin-top: 20px;">{{ $name }}<br />
                            <span style="color: #ff71b8; font-weight: bold; font-size: 24px;">{{ $newData['name'] }}</span></p>
                        </div>
                        <div style="width: 25%">
                            <p style="font-size: 30px; font-weight: bold; margin-bottom: 0px;">${{ $newData['cost'] }}</p>
                            <p style="font-size: 24px; margin-top: 0px;">${{ number_format($newData['plan'], 0, '', '') }} / Mes</p>
                        </div>
                    </div>
                    <p>Siguiente fecha de cobro {{ $next }}</p>
                </td>
            </tr>
            
            <tr style="width: 100%; display:block; text-align:center; padding: 0 0 100px 0;">
                <td class="txt" style="width: 100%; display:block; font-size: 12px; text-align:center; font-weight: 400; padding: 24px 12px 12px; line-height:1.2;">
                    <div class="br">Si ha sido un error, ignora este correo electrónico y no pasará nada.</div>
                    Si los intentos persisten, contáctanos al siguiente correo para darte seguimiento:
                </td>
                <td style="width: 100%; display:block; text-align:center; margin:0 auto;">
                    <a class="txt" href="mailto:hola@glowmeapp.com" style="text-align:center; width: 100%; display:inline-block; margin:0 auto; font-size: 12px; font-weight: 500; color: #ff71b8; line-height:1.2;">
                        hola@glowmeapp.com
                    </a>
                </td>
            </tr>
        </tbody>
        <tfoot style="color:white; background-color:#ff71b8; padding: 12px;">
            <tr style="width: 100%; height: 180px; display:block; color:#fff;">
                <td style="width: 100%; height: 24px; display:block;"></td>
                
                <td class="txt" style="width: 100%; display:block; font-size: 16px;">Hagamos comunidad, síguenos en redes:</td>
                <td style="width: 100%; height:20px; display:block;"></td>
                <td>
                   <div style="display: inline-block;"><a href="https://www.facebook.com/glowmebyzuly" target="_blank"> <img style="width: 40px; height:40px; object-fit:container;" src="http://glowmeapp.com/assets/img/icon-fb.png" alt="GlowMe" style="width:200px; height:auto; object-fit:cover;"></a></div>
                   <div style="display: inline-block; margin: 0 24px;"><a href="https://www.instagram.com/glowmebyzuly/" target="_blank"> <img style="width: 40px; height:40px; object-fit:container;" src="http://glowmeapp.com/assets/img/icon-in.png" alt="GlowMe" style="width:200px; height:auto; object-fit:cover;"></a></div>
                   <div style="display: inline-block;"><a href="https://www.tiktok.com/@glowmebyzuly?_t=8hCdYqnkP26&_r=1" target="_blank"> <img style="width: 40px; height:40px; object-fit:container;" src="http://glowmeapp.com/assets/img/icon-tt.png" alt="GlowMe" style="width:200px; height:auto; object-fit:cover;"></a></div>
                </td>
            </tr>
            <tr>  
                <td style="width: 100%; display:block; color:#BA0F74; height: 50px;">
                    <div class="txt" style="width: 100%; display:block; font-weight: 600;">GlowMe {{ date('Y') }} <span>|</span> Todos los derechos reservados</div>
                    <div class="txt" style="width: 100%; display:block; font-weight: 600;">
                        <a style="color:#BA0F74;" href="http://glowmeapp.com/terms-and-conditions">Términos y condiciones </a>
                        <span>|</span> 
                        <a style="color:#BA0F74;" href="http://glowmeapp.com/privacy-notice">Aviso de privacidad</a>
                    </div>
                </td>
            </tr>
        </tfoot>
    </table>
</body>
</html>