<?php

namespace App\Http\Controllers\Api\Integraciones\Plan;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\Programs;
use App\Models\Clients;
use App\Models\GeneralData;
use App\Models\Recipts;
use App\Models\ProgramRecipts;
use App\Models\CalorieRecipts;
use App\Models\IngredientRecipts;
use App\Models\StepsRecipts;
use App\Models\Ingredients;
use App\Models\Workouts;
use App\Models\WorkoutsVideos;
use App\Models\PlanSemanalControl;
use App\Models\ShoppingList;
use App\Models\ShoppingListDates;

use PDF;

class PlanController extends Controller {
    private $mes = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];
    private $dia = ["DOMINGO", "LUNES", "MARTES", "MIÉRCOLES", "JUEVES", "VIERNES", "SÁBADO"];

    private function dec2frac($dec, $unit) {
        $dec = number_format($dec, 2, '.', '');
        switch ( $unit ) {
            case "scoops":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc <= .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "latas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc <= .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "rebanadas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc <= .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "cucharadas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc > .5 && $fracc < .99 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case "cucharaditas":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc > .5 && $fracc < .99 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'piezas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'tazas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'piezas chicas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case 'piezas medianas':
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                if ( $fracc >= 0 && $fracc < .33 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/4";
                } elseif ( $fracc >= .33 && $fracc < .5 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/3";
                } elseif ( $fracc >= .5 && $fracc < .75 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 1/2";
                } elseif ( $fracc >= .75 && $fracc < 1 ) {
                    return ( $unidad > 0 ) ? $unidad : "" . " 3/4";
                } else {
                    return $unidad + 1;
                }
                break;
            case "mitades":
                $parser = explode ( ".", $dec );
                $unidad = $parser[0];
                $fracc = ".".$parser[1];
                return $unidad + 1;
                break; 
        }
        return $dec;
    }
    
    public function getPlan ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;
                $clientes = Clients::select("nutrition_plan", "workout_plan")->where("id", $r->id)->first();

                $PlanSemanalControl = PlanSemanalControl::where("i_client", $r->id)->orderBy('id', 'DESC')->first();

                if ( $PlanSemanalControl == null || strtotime($PlanSemanalControl['expire_at']) < strtotime(date("Y-m-d"))) {
                    
                    $generalData = GeneralData::select("exceptions", "calories")->where("i_client", $r->id)->first();

                    $programa = ProgramRecipts::select( DB::Raw("GROUP_CONCAT(i_recipt) as recipts") )->where("i_program", $clientes['nutrition_plan'])->get()->toArray();

                    $nutritionPlan = Programs::select("name")->where("id", $clientes['nutrition_plan'])->first();
                    $workouts = Workouts::select("program", "coach")->where("id", $clientes['workout_plan'])->first();

                    $workoutItems = null;
                    if ( $workouts ) {
                        $workoutItems = array();
                        for ( $i = 0; $i < 25; $i++ ) {
                            $workoutPos = GeneralData::select("workout_position")->where("i_client", $r->id)->first();

                            $workoutVid = WorkoutsVideos::select("id", "title", "areas", "equip", "preview", "duration")
                            ->where("i_workout", $clientes['workout_plan'])
                            ->where("id", ">=", $workoutPos['workout_position'])
                            ->get();

                            if (count($workoutVid) > 0 ) { 
                                $data = array(
                                    "id" => $workoutVid[0]['id'],
                                    "clase" => "Clase " . $i+1,
                                    "title" => $workoutVid[0]['title'],
                                    "areas" => $workoutVid[0]['areas'],
                                    "equip" => $workoutVid[0]['equip'],
                                    "preview" => $workoutVid[0]['preview'],
                                    "duration" => $workoutVid[0]['duration']
                                );

                                array_push($workoutItems, $data);

                                if ( isset($workoutVid[1]['id']) ) {
                                    GeneralData::where("i_client", $r->id)->update(["workout_position" => $workoutVid[1]['id']]);
                                } else {
                                    $workoutVid = WorkoutsVideos::select("id")->where("i_workout", $clientes['workout_plan'])->first();
                                    GeneralData::where("i_client", $r->id)->update(["workout_position" => $workoutVid['id']]);
                                }
                            }
                        }
                    }

                    $desayunos = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "desayuno")
                    ->inRandomOrder()
                    ->get()
                    ->toArray();

                    $comidas = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "comida")
                    ->inRandomOrder()
                    ->get()
                    ->toArray();

                    $cenas = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "cena")
                    ->inRandomOrder()
                    ->get()
                    ->toArray();

                    $snack1 = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "snack")
                    ->inRandomOrder()
                    ->get()
                    ->toArray();

                    $snack2 = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "snack")
                    ->inRandomOrder()
                    ->get()
                    ->toArray();

                    // Desayunos
                    $filtrados = array();
                    foreach ( $desayunos as $item ) {
                        $ProgramRecipts = ProgramRecipts::select("id")->where("i_recipt", $item['id'])->where("i_program",$clientes['nutrition_plan'])->first();
                        if ( $ProgramRecipts == null ) { continue; }
                        
                        $CalorieRecipts = CalorieRecipts::select("id")->where("i_program", $ProgramRecipts["id"])->where("i_calorie", $generalData['calories'])->first();
                        if ( $CalorieRecipts == null ) { continue; }
                        
                        $IngredientRecipts = IngredientRecipts::select( DB::Raw("GROUP_CONCAT(i_ingredient) as i_ingredient") )->where("i_calorie", $CalorieRecipts["id"])->first();
                        if ( $IngredientRecipts == null ) { continue; }

                        $ingredientesArray = explode(",", $IngredientRecipts['i_ingredient']);
                        $exceptions = json_decode($generalData["exceptions"], true);
                        $add = true;
                        if ( $exceptions != null ) {
                            foreach( $exceptions as $ex ) {
                                if ( array_search($ex, $ingredientesArray) ) {
                                    $add = false;
                                    break;
                                } 
                            }
                        }
                        if($add){
                            array_push($filtrados, $item);
                        }
                    }
                    $desayunos = $filtrados;

                    // Comidas
                    $filtrados = array();
                    foreach ( $comidas as $item ) {
                        $ProgramRecipts = ProgramRecipts::select("id")->where("i_recipt", $item['id'])->where("i_program",$clientes['nutrition_plan'])->first();
                        if ( $ProgramRecipts == null ) { continue; }
                        
                        $CalorieRecipts = CalorieRecipts::select("id")->where("i_program", $ProgramRecipts["id"])->where("i_calorie", $generalData['calories'])->first();
                        if ( $CalorieRecipts == null ) { continue; }
                        
                        $IngredientRecipts = IngredientRecipts::select( DB::Raw("GROUP_CONCAT(i_ingredient) as i_ingredient") )->where("i_calorie", $CalorieRecipts["id"])->first()->toArray();
                        if ( $IngredientRecipts == null ) { continue; }
                        
                        $ingredientesArray = explode(",", $IngredientRecipts['i_ingredient']);
                        $exceptions = json_decode($generalData["exceptions"], true);
                        $add = true;
                        if ( $exceptions != null ) {
                            foreach( $exceptions as $ex ) {
                                if ( array_search($ex, $ingredientesArray) ) {
                                    $add = false;
                                    break;
                                } 
                            }
                        }
                        if($add){
                            array_push($filtrados, $item);
                        }
                    }
                    $comidas = $filtrados;

                    // Cenas
                    $filtrados = array();
                    foreach ( $cenas as $item ) {
                        $ProgramRecipts = ProgramRecipts::select("id")->where("i_recipt", $item['id'])->where("i_program",$clientes['nutrition_plan'])->first();
                        if ( $ProgramRecipts == null ) { continue; }
                        
                        $CalorieRecipts = CalorieRecipts::select("id")->where("i_program", $ProgramRecipts["id"])->where("i_calorie", $generalData['calories'])->first();
                        if ( $CalorieRecipts == null ) { continue; }
                        
                        $IngredientRecipts = IngredientRecipts::select( DB::Raw("GROUP_CONCAT(i_ingredient) as i_ingredient") )->where("i_calorie", $CalorieRecipts["id"])->first()->toArray();
                        if ( $IngredientRecipts == null ) { continue; }
                        
                        $ingredientesArray = explode(",", $IngredientRecipts['i_ingredient']);
                        $exceptions = json_decode($generalData["exceptions"], true);
                        $add = true;
                        if ( $exceptions != null ) {
                            foreach( $exceptions as $ex ) {
                                if ( array_search($ex, $ingredientesArray) ) {
                                    $add = false;
                                    break;
                                } 
                            }
                        }
                        if($add){
                            array_push($filtrados, $item);
                        }
                    }
                    $cenas = $filtrados;

                    // Snack1
                    $filtrados = array();
                    foreach ( $snack1 as $item ) {
                        $ProgramRecipts = ProgramRecipts::select("id")->where("i_recipt", $item['id'])->where("i_program",$clientes['nutrition_plan'])->first();
                        if ( $ProgramRecipts == null ) { continue; }

                        $CalorieRecipts = CalorieRecipts::select("id")->where("i_program", $ProgramRecipts["id"])->where("i_calorie", $generalData['calories'])->first();
                        if ( $CalorieRecipts == null ) { continue; }

                        $IngredientRecipts = IngredientRecipts::select( DB::Raw("GROUP_CONCAT(i_ingredient) as i_ingredient") )->where("i_calorie", $CalorieRecipts["id"])->first()->toArray();
                        if ( $IngredientRecipts == null ) { continue; }

                        $ingredientesArray = explode(",", $IngredientRecipts['i_ingredient']);
                        $exceptions = json_decode($generalData["exceptions"], true);
                        $add = true;
                        if ( $exceptions != null ) {
                            foreach( $exceptions as $ex ) {
                                if ( array_search($ex, $ingredientesArray) ) {
                                    $add = false;
                                    break;
                                } 
                            }
                        }
                        if($add){
                            array_push($filtrados, $item);
                        }
                    }
                    $snack1 = $filtrados;

                    // Snack2
                    $filtrados = array();
                    foreach ( $snack2 as $item ) {
                        $ProgramRecipts = ProgramRecipts::select("id")->where("i_recipt", $item['id'])->where("i_program",$clientes['nutrition_plan'])->first();
                        if ( $ProgramRecipts == null ) { continue; }

                        $CalorieRecipts = CalorieRecipts::select("id")->where("i_program", $ProgramRecipts["id"])->where("i_calorie", $generalData['calories'])->first();
                        if ( $CalorieRecipts == null ) { continue; }

                        $IngredientRecipts = IngredientRecipts::select( DB::Raw("GROUP_CONCAT(i_ingredient) as i_ingredient") )->where("i_calorie", $CalorieRecipts["id"])->first()->toArray();
                        if ( $IngredientRecipts == null ) { continue; }

                        $ingredientesArray = explode(",", $IngredientRecipts['i_ingredient']);
                        $exceptions = json_decode($generalData["exceptions"], true);
                        $add = true;
                        if ( $exceptions != null ) {
                            foreach( $exceptions as $ex ) {
                                if ( array_search($ex, $ingredientesArray) ) {
                                    $add = false;
                                    break;
                                } 
                            }
                        }
                        if($add){
                            array_push($filtrados, $item);
                        }
                    }
                    $snack2 = $filtrados;

                    $lun1 = date("Y-m-d", strtotime('monday this week')); 
                    $mar1 = date("Y-m-d", strtotime('tuesday this week')); 
                    $mie1 = date("Y-m-d", strtotime('wednesday this week')); 
                    $jue1 = date("Y-m-d", strtotime('thursday this week')); 
                    $vie1 = date("Y-m-d", strtotime('friday this week')); 
                    $sab1 = date("Y-m-d", strtotime('saturday this week')); 
                    $dom1 = date("Y-m-d", strtotime('sunday this week')); 

                    $lun2 = date("Y-m-d", strtotime($lun1 . ' next monday ')); 
                    $mar2 = date("Y-m-d", strtotime($mar1 . ' next tuesday')); 
                    $mie2 = date("Y-m-d", strtotime($mie1 . ' next wednesday')); 
                    $jue2 = date("Y-m-d", strtotime($jue1 . ' next thursday')); 
                    $vie2 = date("Y-m-d", strtotime($vie1 . ' next friday')); 
                    $sab2 = date("Y-m-d", strtotime($sab1 . ' next saturday')); 
                    $dom2 = date("Y-m-d", strtotime($dom1 . ' next sunday')); 

                    $lun3 = date("Y-m-d", strtotime($lun2 . ' next monday ')); 
                    $mar3 = date("Y-m-d", strtotime($mar2 . ' next tuesday')); 
                    $mie3 = date("Y-m-d", strtotime($mie2 . ' next wednesday')); 
                    $jue3 = date("Y-m-d", strtotime($jue2 . ' next thursday')); 
                    $vie3 = date("Y-m-d", strtotime($vie2 . ' next friday')); 
                    $sab3 = date("Y-m-d", strtotime($sab2 . ' next saturday')); 
                    $dom3 = date("Y-m-d", strtotime($dom2 . ' next sunday')); 

                    $lun4 = date("Y-m-d", strtotime($lun3 . ' next monday ')); 
                    $mar4 = date("Y-m-d", strtotime($mar3 . ' next tuesday')); 
                    $mie4 = date("Y-m-d", strtotime($mie3 . ' next wednesday')); 
                    $jue4 = date("Y-m-d", strtotime($jue3 . ' next thursday')); 
                    $vie4 = date("Y-m-d", strtotime($vie3 . ' next friday')); 
                    $sab4 = date("Y-m-d", strtotime($sab3 . ' next saturday')); 
                    $dom4 = date("Y-m-d", strtotime($dom3 . ' next sunday')); 

                    $lun5 = date("Y-m-d", strtotime($lun4 . ' next monday ')); 
                    $mar5 = date("Y-m-d", strtotime($mar4 . ' next tuesday')); 
                    $mie5 = date("Y-m-d", strtotime($mie4 . ' next wednesday')); 
                    $jue5 = date("Y-m-d", strtotime($jue4 . ' next thursday')); 
                    $vie5 = date("Y-m-d", strtotime($vie4 . ' next friday')); 
                    $sab5 = date("Y-m-d", strtotime($sab4 . ' next saturday')); 
                    $dom5 = date("Y-m-d", strtotime($dom4 . ' next sunday')); 

                    // Agregar Plan y Coach
                    $arrayAlimentosList = array();
                    for( $i = 0; $i < 35; $i ++ ) {
                        $des = array_rand($desayunos);
                        $com = array_rand($comidas);
                        $cen = array_rand($cenas);
                        $sn1 = array_rand($snack1);
                        $sn2 = array_rand($snack2);

                        array_push( $arrayAlimentosList, array(
                                "alimento1" => array( 
                                    "id" => $desayunos[$des]['id'] , 
                                    "comida" => strtoupper($desayunos[$des]['food_time']), 
                                    "nombre" => $desayunos[$des]['name'], 
                                    "image" => $_ENV['URL_PATH'].$desayunos[$des]['image'], 
                                ),
                                "alimento2" => array( 
                                    "id" => $snack1[$sn1]['id'] , 
                                    "comida" => strtoupper($snack1[$sn1]['food_time']), 
                                    "nombre" => $snack1[$sn1]['name'], 
                                    "image" => $_ENV['URL_PATH'].$snack1[$sn1]['image'], 
                                ),
                                "alimento3" => array( 
                                    "id" => $comidas[$com]['id'] , 
                                    "comida" => strtoupper($comidas[$com]['food_time']), 
                                    "nombre" => $comidas[$com]['name'], 
                                    "image" => $_ENV['URL_PATH'].$comidas[$com]['image'], 
                                ),
                                "alimento4" => array( 
                                    "id" => $snack2[$sn2]['id'] , 
                                    "comida" => strtoupper($snack2[$sn2]['food_time']), 
                                    "nombre" => $snack2[$sn2]['name'], 
                                    "image" => $_ENV['URL_PATH'].$snack2[$sn2]['image'], 
                                ),
                                "alimento5" => array( 
                                    "id" => $cenas[$cen]['id'] , 
                                    "comida" => strtoupper($cenas[$cen]['food_time']), 
                                    "nombre" => $cenas[$cen]['name'], 
                                    "image" => $_ENV['URL_PATH'].$cenas[$cen]['image'],  
                                ),
                            )
                        );
                    }

                    $result = array ( 
                        "plan_nutricion" => $nutritionPlan['name'],
                        "plan_workout" => $workouts == null ? "N/A" : $workouts['program'],
                        "coach" => $workouts == null ? "N/A" : $workouts['coach'],
                        array( 
                            "semana" => $this->mes[date("n")-1] . " " . date("Y"),
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun1) ) ], 
                                    "numero" => date("d", strtotime($lun1)), 
                                    "fecha" => date("d", strtotime($lun1)) . " de " . $this->mes[date("n", strtotime($lun1))-1] . " " . date("Y", strtotime($lun1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun1)),
                                    "comidas" => $arrayAlimentosList[0],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[0]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[0]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[0]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[0]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[0]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[0]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[0]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar1))], 
                                    "numero" => date("d", strtotime($mar1)), 
                                    "fecha" => date("d", strtotime($mar1)) . " de " . $this->mes[date("n", strtotime($mar1))-1] . " " . date("Y", strtotime($mar1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar1)),
                                    "comidas" => $arrayAlimentosList[1],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[1]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[1]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[1]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[1]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[1]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[1]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[1]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie1))], 
                                    "numero" => date("d", strtotime($mie1)), 
                                    "fecha" => date("d", strtotime($mie1)) . " de " . $this->mes[date("n", strtotime($mie1))-1] . " " . date("Y", strtotime($mie1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie1)),
                                    "comidas" => $arrayAlimentosList[2],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[2]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[2]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[2]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[2]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[2]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[2]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[2]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue1))], 
                                    "numero" => date("d", strtotime($jue1)), 
                                    "fecha" => date("d", strtotime($jue1)) . " de " . $this->mes[date("n", strtotime($jue1))-1] . " " . date("Y", strtotime($jue1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue1)),
                                    "comidas" => $arrayAlimentosList[3],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[3]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[3]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[3]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[3]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[3]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[3]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[3]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie1))], 
                                    "numero" => date("d", strtotime($vie1)), 
                                    "fecha" => date("d", strtotime($vie1)) . " de " . $this->mes[date("n", strtotime($vie1))-1] . " " . date("Y", strtotime($vie1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie1)),
                                    "comidas" => $arrayAlimentosList[4],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[4]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[4]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[4]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[4]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[4]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[4]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[4]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab1))], 
                                    "numero" => date("d", strtotime($sab1)), 
                                    "fecha" => date("d", strtotime($sab1)) . " de " . $this->mes[date("n", strtotime($sab1))-1] . " " . date("Y", strtotime($sab1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab1)),
                                    "comidas" => $arrayAlimentosList[5]/*,
                                    "workout" => array(
                                        "id" => $workoutItems[5]['id'],
                                        "clase" => $workoutItems[5]['clase'],
                                        "nombre" => $workoutItems[5]['title'],
                                        "tiempo" => $workoutItems[5]['duration'] . " min",
                                        "area" => json_decode($workoutItems[5]['areas']),
                                        "equipo" => json_decode($workoutItems[5]['equip']), 
                                        "preview" => $workoutItems[5]['preview']
                                    )*/
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom1))], 
                                    "numero" => date("d", strtotime($dom1)), 
                                    "fecha" => date("d", strtotime($dom1)) . " de " . $this->mes[date("n", strtotime($dom1))-1] . " " . date("Y", strtotime($dom1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom1)),
                                    "comidas" => $arrayAlimentosList[6]/*,
                                    "workout" => array(
                                        "id" => $workoutItems[6]['id'],
                                        "clase" => $workoutItems[6]['clase'],
                                        "nombre" => $workoutItems[6]['title'],
                                        "tiempo" => $workoutItems[6]['duration'] . " min",
                                        "area" => json_decode($workoutItems[6]['areas']),
                                        "equipo" => json_decode($workoutItems[6]['equip']), 
                                        "preview" => $workoutItems[6]['preview']
                                    )*/
                                )
                            )
                        ),
                        array( 
                            "semana" => $this->mes[date("n",strtotime('monday +1 week'))-1] . " " . date("Y"),
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun2) ) ], 
                                    "numero" => date("d", strtotime($lun2)), 
                                    "fecha" => date("d", strtotime($lun2)) . " de " . $this->mes[date("n", strtotime($lun2))-1] . " " . date("Y", strtotime($lun2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun2)),
                                    "comidas" => $arrayAlimentosList[7],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[5]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[5]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[5]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[5]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[5]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[5]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[5]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar2))], 
                                    "numero" => date("d", strtotime($mar2)), 
                                    "fecha" => date("d", strtotime($mar2)) . " de " . $this->mes[date("n", strtotime($mar2))-1] . " " . date("Y", strtotime($mar2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar2)),
                                    "comidas" => $arrayAlimentosList[8],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[6]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[6]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[6]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[6]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[6]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[6]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[6]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie2))], 
                                    "numero" => date("d", strtotime($mie2)), 
                                    "fecha" => date("d", strtotime($mie2)) . " de " . $this->mes[date("n", strtotime($mie2))-1] . " " . date("Y", strtotime($mie2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie2)),
                                    "comidas" => $arrayAlimentosList[9],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[7]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[7]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[7]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[7]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[7]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[7]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[7]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue2))], 
                                    "numero" => date("d", strtotime($jue2)), 
                                    "fecha" => date("d", strtotime($jue2)) . " de " . $this->mes[date("n", strtotime($jue2))-1] . " " . date("Y", strtotime($jue2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue2)),
                                    "comidas" => $arrayAlimentosList[10],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[8]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[8]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[8]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[8]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[8]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[8]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[8]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie2))], 
                                    "numero" => date("d", strtotime($vie2)), 
                                    "fecha" => date("d", strtotime($vie2)) . " de " . $this->mes[date("n", strtotime($vie2))-1] . " " . date("Y", strtotime($vie2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie2)),
                                    "comidas" => $arrayAlimentosList[11],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[9]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[9]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[9]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[9]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[9]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[9]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[9]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab2))], 
                                    "numero" => date("d", strtotime($sab2)), 
                                    "fecha" => date("d", strtotime($sab2)) . " de " . $this->mes[date("n", strtotime($sab2))-1] . " " . date("Y", strtotime($sab2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab2)),
                                    "comidas" => $arrayAlimentosList[12]
                                    /*,
                                    "workout" => array(
                                        "id" => $workoutItems[12]['id'],
                                        "clase" => $workoutItems[12]['clase'],
                                        "nombre" => $workoutItems[12]['title'],
                                        "tiempo" => $workoutItems[12]['duration'] . " min",
                                        "area" => json_decode($workoutItems[12]['areas']),
                                        "equipo" => json_decode($workoutItems[12]['equip']), 
                                        "preview" => $workoutItems[12]['preview']
                                    )*/
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom2))], 
                                    "numero" => date("d", strtotime($dom2)), 
                                    "fecha" => date("d", strtotime($dom2)) . " de " . $this->mes[date("n", strtotime($dom2))-1] . " " . date("Y", strtotime($dom2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom2)),
                                    "comidas" => $arrayAlimentosList[13]
                                    /*,
                                    "workout" => array(
                                        "id" => $workoutItems[13]['id'],
                                        "clase" => $workoutItems[13]['clase'],
                                        "nombre" => $workoutItems[13]['title'],
                                        "tiempo" => $workoutItems[13]['duration'] . " min",
                                        "area" => json_decode($workoutItems[13]['areas']),
                                        "equipo" => json_decode($workoutItems[13]['equip']), 
                                        "preview" => $workoutItems[13]['preview']
                                    )*/
                                )
                            )
                        ),
                        array( 
                            "semana" => $this->mes[date("n",strtotime('monday +2 week'))-1] . " " . date("Y"),
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun3) ) ], 
                                    "numero" => date("d", strtotime($lun3)), 
                                    "fecha" => date("d", strtotime($lun3)) . " de " . $this->mes[date("n", strtotime($lun3))-1] . " " . date("Y", strtotime($lun3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun3)),
                                    "comidas" => $arrayAlimentosList[14],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[10]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[10]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[10]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[10]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[10]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[10]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[10]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar3))], 
                                    "numero" => date("d", strtotime($mar3)), 
                                    "fecha" => date("d", strtotime($mar3)) . " de " . $this->mes[date("n", strtotime($mar3))-1] . " " . date("Y", strtotime($mar3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar3)),
                                    "comidas" => $arrayAlimentosList[15],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[11]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[11]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[11]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[11]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[11]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[11]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[11]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie3))], 
                                    "numero" => date("d", strtotime($mie3)), 
                                    "fecha" => date("d", strtotime($mie3)) . " de " . $this->mes[date("n", strtotime($mie3))-1] . " " . date("Y", strtotime($mie3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie3)),
                                    "comidas" => $arrayAlimentosList[16],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[12]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[12]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[12]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[12]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[12]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[12]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[12]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue3))], 
                                    "numero" => date("d", strtotime($jue3)), 
                                    "fecha" => date("d", strtotime($jue3)) . " de " . $this->mes[date("n", strtotime($jue3))-1] . " " . date("Y", strtotime($jue3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue3)),
                                    "comidas" => $arrayAlimentosList[17],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[13]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[13]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[13]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[13]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[13]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[13]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[13]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie3))], 
                                    "numero" => date("d", strtotime($vie3)), 
                                    "fecha" => date("d", strtotime($vie3)) . " de " . $this->mes[date("n", strtotime($vie3))-1] . " " . date("Y", strtotime($vie3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie3)),
                                    "comidas" => $arrayAlimentosList[18],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[14]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[14]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[14]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[14]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[14]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[14]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[14]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab3))], 
                                    "numero" => date("d", strtotime($sab3)), 
                                    "fecha" => date("d", strtotime($sab3)) . " de " . $this->mes[date("n", strtotime($sab3))-1] . " " . date("Y", strtotime($sab3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab3)),
                                    "comidas" => $arrayAlimentosList[19]
                                    /*,
                                    "workout" => array(
                                        "id" => $workoutItems[19]['id'],
                                        "clase" => $workoutItems[19]['clase'],
                                        "nombre" => $workoutItems[19]['title'],
                                        "tiempo" => $workoutItems[19]['duration'] . " min",
                                        "area" => json_decode($workoutItems[19]['areas']),
                                        "equipo" => json_decode($workoutItems[19]['equip']), 
                                        "preview" => $workoutItems[19]['preview']
                                    )*/
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom3))], 
                                    "numero" => date("d", strtotime($dom3)), 
                                    "fecha" => date("d", strtotime($dom3)) . " de " . $this->mes[date("n", strtotime($dom3))-1] . " " . date("Y", strtotime($dom3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom3)),
                                    "comidas" => $arrayAlimentosList[20]
                                    /*,
                                    "workout" => array(
                                        "id" => $workoutItems[20]['id'],
                                        "clase" => $workoutItems[20]['clase'],
                                        "nombre" => $workoutItems[20]['title'],
                                        "tiempo" => $workoutItems[20]['duration'] . " min",
                                        "area" => json_decode($workoutItems[20]['areas']),
                                        "equipo" => json_decode($workoutItems[20]['equip']), 
                                        "preview" => $workoutItems[20]['preview']
                                    )*/
                                )
                            )
                        ),
                        array( 
                            "semana" => $this->mes[date("n",strtotime('monday +3 week'))-1] . " " . date("Y"),
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun4) ) ], 
                                    "numero" => date("d", strtotime($lun4)), 
                                    "fecha" => date("d", strtotime($lun4)) . " de " . $this->mes[date("n", strtotime($lun4))-1] . " " . date("Y", strtotime($lun4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun4)),
                                    "comidas" => $arrayAlimentosList[21],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[15]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[15]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[15]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[15]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[15]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[15]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[15]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar4))], 
                                    "numero" => date("d", strtotime($mar4)), 
                                    "fecha" => date("d", strtotime($mar4)) . " de " . $this->mes[date("n", strtotime($mar4))-1] . " " . date("Y", strtotime($mar4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar4)),
                                    "comidas" => $arrayAlimentosList[22],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[16]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[16]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[16]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[16]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[16]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[16]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[16]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie4))], 
                                    "numero" => date("d", strtotime($mie4)), 
                                    "fecha" => date("d", strtotime($mie4)) . " de " . $this->mes[date("n", strtotime($mie4))-1] . " " . date("Y", strtotime($mie4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie4)),
                                    "comidas" => $arrayAlimentosList[23],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[17]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[17]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[17]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[17]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[17]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[17]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[17]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue4))], 
                                    "numero" => date("d", strtotime($jue3)), 
                                    "fecha" => date("d", strtotime($jue4)) . " de " . $this->mes[date("n", strtotime($jue4))-1] . " " . date("Y", strtotime($jue4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue4)),
                                    "comidas" => $arrayAlimentosList[24],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[18]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[18]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[18]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[18]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[18]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[18]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[18]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie4))], 
                                    "numero" => date("d", strtotime($vie4)), 
                                    "fecha" => date("d", strtotime($vie4)) . " de " . $this->mes[date("n", strtotime($vie4))-1] . " " . date("Y", strtotime($vie4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie4)),
                                    "comidas" => $arrayAlimentosList[25],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[19]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[19]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[19]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[19]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[19]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[19]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[19]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab4))], 
                                    "numero" => date("d", strtotime($sab4)), 
                                    "fecha" => date("d", strtotime($sab4)) . " de " . $this->mes[date("n", strtotime($sab4))-1] . " " . date("Y", strtotime($sab4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab4)),
                                    "comidas" => $arrayAlimentosList[26]
                                    /*,
                                    "workout" => array(
                                        "id" => $workoutItems[26]['id'],
                                        "clase" => $workoutItems[26]['clase'],
                                        "nombre" => $workoutItems[26]['title'],
                                        "tiempo" => $workoutItems[26]['duration'] . " min",
                                        "area" => json_decode($workoutItems[26]['areas']),
                                        "equipo" => json_decode($workoutItems[26]['equip']), 
                                        "preview" => $workoutItems[26]['preview']
                                    )*/
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom4))], 
                                    "numero" => date("d", strtotime($dom4)), 
                                    "fecha" => date("d", strtotime($dom4)) . " de " . $this->mes[date("n", strtotime($dom4))-1] . " " . date("Y", strtotime($dom4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom4)),
                                    "comidas" => $arrayAlimentosList[27]
                                    /*,
                                    "workout" => array(
                                        "id" => $workoutItems[27]['id'],
                                        "clase" => $workoutItems[27]['clase'],
                                        "nombre" => $workoutItems[27]['title'],
                                        "tiempo" => $workoutItems[27]['duration'] . " min",
                                        "area" => json_decode($workoutItems[27]['areas']),
                                        "equipo" => json_decode($workoutItems[27]['equip']), 
                                        "preview" => $workoutItems[27]['preview']
                                    )*/
                                )
                            )
                        ),
                        array( 
                            "semana" => $this->mes[date("n",strtotime('monday +4 week'))-1] . " " . date("Y"),
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun5) ) ], 
                                    "numero" => date("d", strtotime($lun5)), 
                                    "fecha" => date("d", strtotime($lun5)) . " de " . $this->mes[date("n", strtotime($lun5))-1] . " " . date("Y", strtotime($lun5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun5)),
                                    "comidas" => $arrayAlimentosList[28],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[20]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[20]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[20]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[20]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[20]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[20]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[20]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar5))], 
                                    "numero" => date("d", strtotime($mar5)), 
                                    "fecha" => date("d", strtotime($mar5)) . " de " . $this->mes[date("n", strtotime($mar5))-1] . " " . date("Y", strtotime($mar5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar5)),
                                    "comidas" => $arrayAlimentosList[29],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[21]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[21]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[21]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[21]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[21]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[21]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[21]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie5))], 
                                    "numero" => date("d", strtotime($mie5)), 
                                    "fecha" => date("d", strtotime($mie5)) . " de " . $this->mes[date("n", strtotime($mie5))-1] . " " . date("Y", strtotime($mie5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie5)),
                                    "comidas" => $arrayAlimentosList[30],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[22]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[22]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[22]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[22]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[22]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[22]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[22]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue5))], 
                                    "numero" => date("d", strtotime($jue5)), 
                                    "fecha" => date("d", strtotime($jue5)) . " de " . $this->mes[date("n", strtotime($jue5))-1] . " " . date("Y", strtotime($jue5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue5)),
                                    "comidas" => $arrayAlimentosList[31],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[23]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[23]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[23]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[23]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[23]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[23]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[23]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie5))], 
                                    "numero" => date("d", strtotime($vie5)), 
                                    "fecha" => date("d", strtotime($vie5)) . " de " . $this->mes[date("n", strtotime($vie5))-1] . " " . date("Y", strtotime($vie5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie5)),
                                    "comidas" => $arrayAlimentosList[32],
                                    "workout" => array(
                                        "id" => $workoutItems == null ? "N/A" : $workoutItems[24]['id'],
                                        "clase" => $workoutItems == null ? "N/A" : $workoutItems[24]['clase'],
                                        "nombre" => $workoutItems == null ? "N/A" : $workoutItems[24]['title'],
                                        "tiempo" => $workoutItems == null ? "N/A" : $workoutItems[24]['duration'] . " min",
                                        "area" => $workoutItems == null ? "N/A" : json_decode($workoutItems[24]['areas']),
                                        "equipo" => $workoutItems == null ? "N/A" : json_decode($workoutItems[24]['equip']), 
                                        "preview" => $workoutItems == null ? "N/A" : $workoutItems[24]['preview']
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab5))], 
                                    "numero" => date("d", strtotime($sab5)), 
                                    "fecha" => date("d", strtotime($sab5)) . " de " . $this->mes[date("n", strtotime($sab5))-1] . " " . date("Y", strtotime($sab5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab5)),
                                    "comidas" => $arrayAlimentosList[33]/*,
                                    "workout" => array(
                                        "id" => $workoutItems[33]['id'],
                                        "clase" => $workoutItems[33]['clase'],
                                        "nombre" => $workoutItems[33]['title'],
                                        "tiempo" => $workoutItems[33]['duration'] . " min",
                                        "area" => json_decode($workoutItems[33]['areas']),
                                        "equipo" => json_decode($workoutItems[33]['equip']), 
                                        "preview" => $workoutItems[33]['preview']
                                    )*/
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom5))], 
                                    "numero" => date("d", strtotime($dom5)), 
                                    "fecha" => date("d", strtotime($dom5)) . " de " . $this->mes[date("n", strtotime($dom5))-1] . " " . date("Y", strtotime($dom5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom5)),
                                    "comidas" => $arrayAlimentosList[34]
                                    /*,
                                    "workout" => array(
                                        "id" => $workoutItems[34]['id'],
                                        "clase" => $workoutItems[34]['clase'],
                                        "nombre" => $workoutItems[34]['title'],
                                        "tiempo" => $workoutItems[34]['duration'] . " min",
                                        "area" => json_decode($workoutItems[34]['areas']),
                                        "equipo" => json_decode($workoutItems[34]['equip']), 
                                        "preview" => $workoutItems[34]['preview']
                                    )*/
                                )
                            )
                        ),
                    );

                    ShoppingListDates::where("i_client", $r->id)->delete();
                    foreach ( $result as $key => $itemSemana ) {
                        if ( $key == 0 || $key == 1 || $key == 2 || $key == 3 || $key == 4 ) {
                            foreach ( $itemSemana['dias'] as $item ) {

                                $ShoppingListDates = new ShoppingListDates();
                                $ShoppingListDates->i_client = $r->id;
                                $ShoppingListDates->date_at = date("Y-m-d", strtotime($item["fecha_formato"]));
                                $ShoppingListDates->save();

                                foreach ( $item['comidas'] as $itemFood ) {
                                    if ( $itemFood["id"] != 0 ){
                                        $programaReceta = ProgramRecipts::select("id")->where("i_recipt", $itemFood['id'])->where("i_program", $clientes['nutrition_plan'])->first();

                                        if ( $itemFood['comida'] == "SNACK" ){
                                            $generalDataCalories = 1100;
                                        } else {
                                            $generalDataCalories = $generalData['calories'];
                                        }

                                        if ( $generalData['calories'] < 1100 ) {
                                            $generalDataCalories = 1100;
                                        } elseif ( $generalData['calories'] == 2100 ) {
                                            $generalDataCalories = 2000;
                                        }

                                        $calorieRecipts = CalorieRecipts::select("id")->where("i_program", $programaReceta['id'])->where("i_calorie", $generalDataCalories)->first();
                                        
                                        $ingredientRecipts = IngredientRecipts::select("i_ingredient", "portion")->where("i_calorie", $calorieRecipts['id'])->get()->toArray();

                                        foreach ( $ingredientRecipts as $itemIngredient ) {
                                            $ingredients = Ingredients::select("name", "portion", "unit")->where("id", $itemIngredient["i_ingredient"])->first();

                                            $ShoppingList = new ShoppingList();
                                            $ShoppingList->i_shopping_date = $ShoppingListDates->id;
                                            $ShoppingList->item = $itemIngredient["i_ingredient"];
                                            $ShoppingList->item_name = $ingredients["name"];
                                            $ShoppingList->quantity = $this->dec2frac($itemIngredient["portion"] * $ingredients["portion"], $ingredients["unit"]);
                                            $ShoppingList->i_unit = $ingredients["unit"];
                                            $ShoppingList->save();
                                        }
                                    }
                                }   
                            }
                        }
                    }

                    $PlanSemanalControl = new PlanSemanalControl();
                    $PlanSemanalControl->i_client = $r->id;
                    $PlanSemanalControl->json = json_encode($result);
                    $PlanSemanalControl->expire_at = $dom5;
                    $PlanSemanalControl->save();
                } else {
                    $result = json_decode($PlanSemanalControl['json']);
                }

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getWeekPlan ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $restResponse = 200;

                $clientes = Clients::select("nutrition_plan", "workout_plan")->where("id", $r->id)->first();

                $PlanSemanalControl = PlanSemanalControl::where("i_client", $r->id)->orderBy('id', 'DESC')->first();

                $data = json_decode($PlanSemanalControl['json'], true) ;

                //dd( $data[0]['dias'][0]['comidas'] );

                $result = array ( 
                    array( 
                        "semana" => $data[0]['dias'][0]['numero'] . " al " . $data[0]['dias'][6]['numero'] . " de " . $this->mes[date("n", strtotime($data[0]['dias'][6]['fecha_formato']))-1],
                        "dias" => array(
                            array( 
                                "dia" => $data[0]['dias'][0]['dia'], 
                                "fecha" => $data[0]['dias'][0]['fecha'],
                                "fecha_formato" => $data[0]['dias'][0]['fecha_formato'],
                                "comidas" => $data[0]['dias'][0]['comidas']
                            ),
                            array( 
                                "dia" => $data[0]['dias'][1]['dia'], 
                                "fecha" => $data[0]['dias'][1]['fecha'],
                                "fecha_formato" => $data[0]['dias'][1]['fecha_formato'],
                                "comidas" => $data[0]['dias'][1]['comidas']
                            ),
                            array( 
                                "dia" => $data[0]['dias'][2]['dia'], 
                                "fecha" => $data[0]['dias'][2]['fecha'],
                                "fecha_formato" => $data[0]['dias'][2]['fecha_formato'],
                                "comidas" => $data[0]['dias'][2]['comidas']
                            ),
                            array( 
                                "dia" => $data[0]['dias'][3]['dia'], 
                                "fecha" => $data[0]['dias'][3]['fecha'],
                                "fecha_formato" => $data[0]['dias'][3]['fecha_formato'],
                                "comidas" => $data[0]['dias'][3]['comidas']
                            ),
                            array( 
                                "dia" => $data[0]['dias'][4]['dia'], 
                                "fecha" => $data[0]['dias'][4]['fecha'],
                                "fecha_formato" => $data[0]['dias'][4]['fecha_formato'],
                                "comidas" => $data[0]['dias'][4]['comidas']
                            ),
                            array( 
                                "dia" => $data[0]['dias'][5]['dia'], 
                                "fecha" => $data[0]['dias'][5]['fecha'],
                                "fecha_formato" => $data[0]['dias'][5]['fecha_formato'],
                                "comidas" => $data[0]['dias'][5]['comidas']
                            ),
                            array( 
                                "dia" => $data[0]['dias'][6]['dia'], 
                                "fecha" => $data[0]['dias'][6]['fecha'],
                                "fecha_formato" => $data[0]['dias'][6]['fecha_formato'],
                                "comidas" => $data[0]['dias'][6]['comidas']
                            )
                        )
                    ),
                    array( 
                        "semana" => $data[1]['dias'][0]['numero'] . " al " . $data[1]['dias'][6]['numero'] . " de " . $this->mes[date("n", strtotime($data[1]['dias'][6]['fecha_formato']))-1],
                        "dias" => array(
                            array( 
                                "dia" => $data[1]['dias'][0]['dia'], 
                                "fecha" => $data[1]['dias'][0]['fecha'],
                                "fecha_formato" => $data[1]['dias'][0]['fecha_formato'],
                                "comidas" => $data[1]['dias'][0]['comidas']
                            ),
                            array( 
                                "dia" => $data[1]['dias'][1]['dia'], 
                                "fecha" => $data[1]['dias'][1]['fecha'],
                                "fecha_formato" => $data[1]['dias'][1]['fecha_formato'],
                                "comidas" => $data[1]['dias'][1]['comidas']
                            ),
                            array( 
                                "dia" => $data[1]['dias'][2]['dia'], 
                                "fecha" => $data[1]['dias'][2]['fecha'],
                                "fecha_formato" => $data[1]['dias'][2]['fecha_formato'],
                                "comidas" => $data[1]['dias'][2]['comidas']
                            ),
                            array( 
                                "dia" => $data[1]['dias'][3]['dia'], 
                                "fecha" => $data[1]['dias'][3]['fecha'],
                                "fecha_formato" => $data[1]['dias'][3]['fecha_formato'],
                                "comidas" => $data[1]['dias'][3]['comidas']
                            ),
                            array( 
                                "dia" => $data[1]['dias'][4]['dia'], 
                                "fecha" => $data[1]['dias'][4]['fecha'],
                                "fecha_formato" => $data[1]['dias'][4]['fecha_formato'],
                                "comidas" => $data[1]['dias'][4]['comidas']
                            ),
                            array( 
                                "dia" => $data[1]['dias'][5]['dia'], 
                                "fecha" => $data[1]['dias'][5]['fecha'],
                                "fecha_formato" => $data[1]['dias'][5]['fecha_formato'],
                                "comidas" => $data[1]['dias'][5]['comidas']
                            ),
                            array( 
                                "dia" => $data[1]['dias'][6]['dia'], 
                                "fecha" => $data[1]['dias'][6]['fecha'],
                                "fecha_formato" => $data[1]['dias'][6]['fecha_formato'],
                                "comidas" => $data[1]['dias'][6]['comidas']
                            )
                        )
                    ),
                    array( 
                        "semana" => $data[2]['dias'][0]['numero'] . " al " . $data[2]['dias'][6]['numero'] . " de " . $this->mes[date("n", strtotime($data[2]['dias'][6]['fecha_formato']))-1],
                        "dias" => array(
                            array( 
                                "dia" => $data[2]['dias'][0]['dia'], 
                                "fecha" => $data[2]['dias'][0]['fecha'],
                                "fecha_formato" => $data[2]['dias'][0]['fecha_formato'],
                                "comidas" => $data[2]['dias'][0]['comidas']
                            ),
                            array( 
                                "dia" => $data[2]['dias'][1]['dia'], 
                                "fecha" => $data[2]['dias'][1]['fecha'],
                                "fecha_formato" => $data[2]['dias'][1]['fecha_formato'],
                                "comidas" => $data[2]['dias'][1]['comidas']
                            ),
                            array( 
                                "dia" => $data[2]['dias'][2]['dia'], 
                                "fecha" => $data[2]['dias'][2]['fecha'],
                                "fecha_formato" => $data[2]['dias'][2]['fecha_formato'],
                                "comidas" => $data[2]['dias'][2]['comidas']
                            ),
                            array( 
                                "dia" => $data[2]['dias'][3]['dia'], 
                                "fecha" => $data[2]['dias'][3]['fecha'],
                                "fecha_formato" => $data[2]['dias'][3]['fecha_formato'],
                                "comidas" => $data[2]['dias'][3]['comidas']
                            ),
                            array( 
                                "dia" => $data[2]['dias'][4]['dia'], 
                                "fecha" => $data[2]['dias'][4]['fecha'],
                                "fecha_formato" => $data[2]['dias'][4]['fecha_formato'],
                                "comidas" => $data[2]['dias'][4]['comidas']
                            ),
                            array( 
                                "dia" => $data[2]['dias'][5]['dia'], 
                                "fecha" => $data[2]['dias'][5]['fecha'],
                                "fecha_formato" => $data[2]['dias'][5]['fecha_formato'],
                                "comidas" => $data[2]['dias'][5]['comidas']
                            ),
                            array( 
                                "dia" => $data[2]['dias'][6]['dia'], 
                                "fecha" => $data[2]['dias'][6]['fecha'],
                                "fecha_formato" => $data[2]['dias'][6]['fecha_formato'],
                                "comidas" => $data[2]['dias'][6]['comidas']
                            )
                        )
                    ),
                    array( 
                        "semana" => $data[3]['dias'][0]['numero'] . " al " . $data[3]['dias'][6]['numero'] . " de " . $this->mes[date("n", strtotime($data[3]['dias'][6]['fecha_formato']))-1],
                        "dias" => array(
                            array( 
                                "dia" => $data[3]['dias'][0]['dia'], 
                                "fecha" => $data[3]['dias'][0]['fecha'],
                                "fecha_formato" => $data[3]['dias'][0]['fecha_formato'],
                                "comidas" => $data[3]['dias'][0]['comidas']
                            ),
                            array( 
                                "dia" => $data[3]['dias'][1]['dia'], 
                                "fecha" => $data[3]['dias'][1]['fecha'],
                                "fecha_formato" => $data[3]['dias'][1]['fecha_formato'],
                                "comidas" => $data[3]['dias'][1]['comidas']
                            ),
                            array( 
                                "dia" => $data[3]['dias'][2]['dia'], 
                                "fecha" => $data[3]['dias'][2]['fecha'],
                                "fecha_formato" => $data[3]['dias'][2]['fecha_formato'],
                                "comidas" => $data[3]['dias'][2]['comidas']
                            ),
                            array( 
                                "dia" => $data[3]['dias'][3]['dia'], 
                                "fecha" => $data[3]['dias'][3]['fecha'],
                                "fecha_formato" => $data[3]['dias'][3]['fecha_formato'],
                                "comidas" => $data[3]['dias'][3]['comidas']
                            ),
                            array( 
                                "dia" => $data[3]['dias'][4]['dia'], 
                                "fecha" => $data[3]['dias'][4]['fecha'],
                                "fecha_formato" => $data[3]['dias'][4]['fecha_formato'],
                                "comidas" => $data[3]['dias'][4]['comidas']
                            ),
                            array( 
                                "dia" => $data[3]['dias'][5]['dia'], 
                                "fecha" => $data[3]['dias'][5]['fecha'],
                                "fecha_formato" => $data[3]['dias'][5]['fecha_formato'],
                                "comidas" => $data[3]['dias'][5]['comidas']
                            ),
                            array( 
                                "dia" => $data[3]['dias'][6]['dia'], 
                                "fecha" => $data[3]['dias'][6]['fecha'],
                                "fecha_formato" => $data[3]['dias'][6]['fecha_formato'],
                                "comidas" => $data[3]['dias'][6]['comidas']
                            )
                        )
                    ),
                    array( 
                        "semana" => $data[4]['dias'][0]['numero'] . " al " . $data[4]['dias'][6]['numero'] . " de " . $this->mes[date("n", strtotime($data[4]['dias'][6]['fecha_formato']))-1],
                        "dias" => array(
                            array( 
                                "dia" => $data[4]['dias'][0]['dia'], 
                                "fecha" => $data[4]['dias'][0]['fecha'],
                                "fecha_formato" => $data[4]['dias'][0]['fecha_formato'],
                                "comidas" => $data[4]['dias'][0]['comidas']
                            ),
                            array( 
                                "dia" => $data[4]['dias'][1]['dia'], 
                                "fecha" => $data[4]['dias'][1]['fecha'],
                                "fecha_formato" => $data[4]['dias'][1]['fecha_formato'],
                                "comidas" => $data[4]['dias'][1]['comidas']
                            ),
                            array( 
                                "dia" => $data[4]['dias'][2]['dia'], 
                                "fecha" => $data[4]['dias'][2]['fecha'],
                                "fecha_formato" => $data[4]['dias'][2]['fecha_formato'],
                                "comidas" => $data[4]['dias'][2]['comidas']
                            ),
                            array( 
                                "dia" => $data[4]['dias'][3]['dia'], 
                                "fecha" => $data[4]['dias'][3]['fecha'],
                                "fecha_formato" => $data[4]['dias'][3]['fecha_formato'],
                                "comidas" => $data[4]['dias'][3]['comidas']
                            ),
                            array( 
                                "dia" => $data[4]['dias'][4]['dia'], 
                                "fecha" => $data[4]['dias'][4]['fecha'],
                                "fecha_formato" => $data[4]['dias'][4]['fecha_formato'],
                                "comidas" => $data[4]['dias'][4]['comidas']
                            ),
                            array( 
                                "dia" => $data[4]['dias'][5]['dia'], 
                                "fecha" => $data[4]['dias'][5]['fecha'],
                                "fecha_formato" => $data[4]['dias'][5]['fecha_formato'],
                                "comidas" => $data[4]['dias'][5]['comidas']
                            ),
                            array( 
                                "dia" => $data[4]['dias'][6]['dia'], 
                                "fecha" => $data[4]['dias'][6]['fecha'],
                                "fecha_formato" => $data[4]['dias'][6]['fecha_formato'],
                                "comidas" => $data[4]['dias'][6]['comidas']
                            )
                        )
                    ),
                );

                /*
                if ( $PlanSemanalControl == null || strtotime($PlanSemanalControl['expire_at']) < strtotime(date("Y-m-d"))) {
                    $programa = ProgramRecipts::select( DB::Raw("GROUP_CONCAT(i_recipt) as recipts") )->where("i_program", $clientes['nutrition_plan'])->get()->toArray();

                    $desayunos = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "desayuno")
                    ->inRandomOrder()
                    ->take("35")
                    ->get()
                    ->toArray();

                    $comidas = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "comida")
                    ->inRandomOrder()
                    ->take("35")
                    ->get()
                    ->toArray();

                    $cenas = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "cena")
                    ->inRandomOrder()
                    ->take("35")
                    ->get()
                    ->toArray();

                    $snack1 = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "snack")
                    ->inRandomOrder()
                    ->take("35")
                    ->get()
                    ->toArray();

                    $snack2 = Recipts::select("id", "food_time", "name", "image")->whereIn("id", explode(",", $programa[0]['recipts']))
                    ->where("food_time", "snack")
                    ->inRandomOrder()
                    ->take("35")
                    ->get()
                    ->toArray();

                    $lun1 = date("Y-m-d", strtotime('monday this week')); 
                    $mar1 = date("Y-m-d", strtotime('tuesday this week')); 
                    $mie1 = date("Y-m-d", strtotime('wednesday this week')); 
                    $jue1 = date("Y-m-d", strtotime('thursday this week')); 
                    $vie1 = date("Y-m-d", strtotime('friday this week')); 
                    $sab1 = date("Y-m-d", strtotime('saturday this week')); 
                    $dom1 = date("Y-m-d", strtotime('sunday this week')); 

                    $lun2 = date("Y-m-d", strtotime($lun1 . ' next monday ')); 
                    $mar2 = date("Y-m-d", strtotime($mar1 . ' next tuesday')); 
                    $mie2 = date("Y-m-d", strtotime($mie1 . ' next wednesday')); 
                    $jue2 = date("Y-m-d", strtotime($jue1 . ' next thursday')); 
                    $vie2 = date("Y-m-d", strtotime($vie1 . ' next friday')); 
                    $sab2 = date("Y-m-d", strtotime($sab1 . ' next saturday')); 
                    $dom2 = date("Y-m-d", strtotime($dom1 . ' next sunday')); 

                    $lun3 = date("Y-m-d", strtotime($lun2 . ' next monday ')); 
                    $mar3 = date("Y-m-d", strtotime($mar2 . ' next tuesday')); 
                    $mie3 = date("Y-m-d", strtotime($mie2 . ' next wednesday')); 
                    $jue3 = date("Y-m-d", strtotime($jue2 . ' next thursday')); 
                    $vie3 = date("Y-m-d", strtotime($vie2 . ' next friday')); 
                    $sab3 = date("Y-m-d", strtotime($sab2 . ' next saturday')); 
                    $dom3 = date("Y-m-d", strtotime($dom2 . ' next sunday')); 

                    $lun4 = date("Y-m-d", strtotime($lun3 . ' next monday ')); 
                    $mar4 = date("Y-m-d", strtotime($mar3 . ' next tuesday')); 
                    $mie4 = date("Y-m-d", strtotime($mie3 . ' next wednesday')); 
                    $jue4 = date("Y-m-d", strtotime($jue3 . ' next thursday')); 
                    $vie4 = date("Y-m-d", strtotime($vie3 . ' next friday')); 
                    $sab4 = date("Y-m-d", strtotime($sab3 . ' next saturday')); 
                    $dom4 = date("Y-m-d", strtotime($dom3 . ' next sunday')); 

                    $lun5 = date("Y-m-d", strtotime($lun4 . ' next monday ')); 
                    $mar5 = date("Y-m-d", strtotime($mar4 . ' next tuesday')); 
                    $mie5 = date("Y-m-d", strtotime($mie4 . ' next wednesday')); 
                    $jue5 = date("Y-m-d", strtotime($jue4 . ' next thursday')); 
                    $vie5 = date("Y-m-d", strtotime($vie4 . ' next friday')); 
                    $sab5 = date("Y-m-d", strtotime($sab4 . ' next saturday')); 
                    $dom5 = date("Y-m-d", strtotime($dom4 . ' next sunday')); 

                    // Agregar Plan y Coach

                    $result = array ( 
                        array( 
                            "semana" => date("d", strtotime($lun1)) . " al " . date("d", strtotime($dom1)) . " de " . $this->mes[date("n", strtotime($lun1))-1],
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun1) ) ], 
                                    "fecha" => date("d", strtotime($lun1)) . " de " . $this->mes[date("n", strtotime($lun1))-1] . " " . date("Y", strtotime($lun1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun1)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[0]['id']) ? $desayunos[0]['id'] : '0' , 
                                            "comida" => isset($desayunos[0]['food_time']) ? strtoupper($desayunos[0]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[0]['name']) ? $desayunos[0]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[0]['image']) ? $_ENV['URL_PATH'].$desayunos[0]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[0]['id']) ? $snack1[0]['id'] : '0' , 
                                            "comida" => isset($snack1[0]['food_time']) ? strtoupper($snack1[0]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[0]['name']) ? $snack1[0]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[0]['image']) ? $_ENV['URL_PATH'].$snack1[0]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[0]['id']) ? $comidas[0]['id'] : '0' , 
                                            "comida" => isset($comidas[0]['food_time']) ? strtoupper($comidas[0]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[0]['name']) ? $comidas[0]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[0]['image']) ? $_ENV['URL_PATH'].$comidas[0]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[0]['id']) ? $snack2[0]['id'] : '0' , 
                                            "comida" => isset($snack2[0]['food_time']) ? strtoupper($snack2[0]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[0]['name']) ? $snack2[0]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[0]['image']) ? $_ENV['URL_PATH'].$snack2[0]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[0]['id']) ? $cenas[0]['id'] : '0' , 
                                            "comida" => isset($cenas[0]['food_time']) ? strtoupper($cenas[0]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[0]['name']) ? $cenas[0]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[0]['image']) ? $_ENV['URL_PATH'].$cenas[0]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar1))], 
                                    "fecha" => date("d", strtotime($mar1)) . " de " . $this->mes[date("n", strtotime($mar1))-1] . " " . date("Y", strtotime($mar1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar1)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[1]['id']) ? $desayunos[1]['id'] : '0' , 
                                            "comida" => isset($desayunos[1]['food_time']) ? strtoupper($desayunos[1]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[1]['name']) ? $desayunos[1]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[1]['image']) ? $_ENV['URL_PATH'].$desayunos[1]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[1]['id']) ? $snack1[1]['id'] : '0' , 
                                            "comida" => isset($snack1[1]['food_time']) ? strtoupper($snack1[1]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[1]['name']) ? $snack1[1]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[1]['image']) ? $_ENV['URL_PATH'].$snack1[1]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[1]['id']) ? $comidas[1]['id'] : '0' , 
                                            "comida" => isset($comidas[1]['food_time']) ? strtoupper($comidas[1]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[1]['name']) ? $comidas[1]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[1]['image']) ? $_ENV['URL_PATH'].$comidas[1]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[1]['id']) ? $snack2[1]['id'] : '0' , 
                                            "comida" => isset($snack2[1]['food_time']) ? strtoupper($snack2[1]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[1]['name']) ? $snack2[1]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[1]['image']) ? $_ENV['URL_PATH'].$snack2[1]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[1]['id']) ? $cenas[1]['id'] : '0' , 
                                            "comida" => isset($cenas[1]['food_time']) ? strtoupper($cenas[1]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[1]['name']) ? $cenas[1]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[1]['image']) ? $_ENV['URL_PATH'].$cenas[1]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie1))], 
                                    "fecha" => date("d", strtotime($mie1)) . " de " . $this->mes[date("n", strtotime($mie1))-1] . " " . date("Y", strtotime($mie1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie1)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[2]['id']) ? $desayunos[2]['id'] : '0' , 
                                            "comida" => isset($desayunos[2]['food_time']) ? strtoupper($desayunos[2]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[2]['name']) ? $desayunos[2]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[2]['image']) ? $_ENV['URL_PATH'].$desayunos[2]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[2]['id']) ? $snack1[2]['id'] : '0' , 
                                            "comida" => isset($snack1[2]['food_time']) ? strtoupper($snack1[2]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[2]['name']) ? $snack1[2]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[2]['image']) ? $_ENV['URL_PATH'].$snack1[2]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[2]['id']) ? $comidas[2]['id'] : '0' , 
                                            "comida" => isset($comidas[2]['food_time']) ? strtoupper($comidas[2]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[2]['name']) ? $comidas[2]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[2]['image']) ? $_ENV['URL_PATH'].$comidas[2]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[2]['id']) ? $snack2[2]['id'] : '0' , 
                                            "comida" => isset($snack2[2]['food_time']) ? strtoupper($snack2[2]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[2]['name']) ? $snack2[2]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[2]['image']) ? $_ENV['URL_PATH'].$snack2[2]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[2]['id']) ? $cenas[2]['id'] : '0' , 
                                            "comida" => isset($cenas[2]['food_time']) ? strtoupper($cenas[2]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[2]['name']) ? $cenas[2]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[2]['image']) ? $_ENV['URL_PATH'].$cenas[2]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue1))], 
                                    "fecha" => date("d", strtotime($jue1)) . " de " . $this->mes[date("n", strtotime($jue1))-1] . " " . date("Y", strtotime($jue1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue1)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[3]['id']) ? $desayunos[3]['id'] : '0' , 
                                            "comida" => isset($desayunos[3]['food_time']) ? strtoupper($desayunos[3]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[3]['name']) ? $desayunos[3]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[3]['image']) ? $_ENV['URL_PATH'].$desayunos[3]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[3]['id']) ? $snack1[3]['id'] : '0' , 
                                            "comida" => isset($snack1[3]['food_time']) ? strtoupper($snack1[3]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[3]['name']) ? $snack1[3]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[3]['image']) ? $_ENV['URL_PATH'].$snack1[3]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[3]['id']) ? $comidas[3]['id'] : '0' , 
                                            "comida" => isset($comidas[3]['food_time']) ? strtoupper($comidas[3]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[3]['name']) ? $comidas[3]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[3]['image']) ? $_ENV['URL_PATH'].$comidas[3]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[3]['id']) ? $snack2[3]['id'] : '0' , 
                                            "comida" => isset($snack2[3]['food_time']) ? strtoupper($snack2[3]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[3]['name']) ? $snack2[3]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[3]['image']) ? $_ENV['URL_PATH'].$snack2[3]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[3]['id']) ? $cenas[3]['id'] : '0' , 
                                            "comida" => isset($cenas[3]['food_time']) ? strtoupper($cenas[3]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[3]['name']) ? $cenas[3]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[3]['image']) ? $_ENV['URL_PATH'].$cenas[3]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie1))], 
                                    "fecha" => date("d", strtotime($vie1)) . " de " . $this->mes[date("n", strtotime($vie1))-1] . " " . date("Y", strtotime($vie1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie1)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[4]['id']) ? $desayunos[4]['id'] : '0' , 
                                            "comida" => isset($desayunos[4]['food_time']) ? strtoupper($desayunos[4]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[4]['name']) ? $desayunos[4]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[4]['image']) ? $_ENV['URL_PATH'].$desayunos[4]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[4]['id']) ? $snack1[4]['id'] : '0' , 
                                            "comida" => isset($snack1[4]['food_time']) ? strtoupper($snack1[4]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[4]['name']) ? $snack1[4]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[4]['image']) ? $_ENV['URL_PATH'].$snack1[4]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[4]['id']) ? $comidas[4]['id'] : '0' , 
                                            "comida" => isset($comidas[4]['food_time']) ? strtoupper($comidas[4]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[4]['name']) ? $comidas[4]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[4]['image']) ? $_ENV['URL_PATH'].$comidas[4]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[4]['id']) ? $snack2[4]['id'] : '0' , 
                                            "comida" => isset($snack2[4]['food_time']) ? strtoupper($snack2[4]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[4]['name']) ? $snack2[4]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[4]['image']) ? $_ENV['URL_PATH'].$snack2[4]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[4]['id']) ? $cenas[4]['id'] : '0' , 
                                            "comida" => isset($cenas[4]['food_time']) ? strtoupper($cenas[4]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[4]['name']) ? $cenas[4]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[4]['image']) ? $_ENV['URL_PATH'].$cenas[4]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab1))], 
                                    "fecha" => date("d", strtotime($sab1)) . " de " . $this->mes[date("n", strtotime($sab1))-1] . " " . date("Y", strtotime($sab1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab1)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[5]['id']) ? $desayunos[5]['id'] : '0' , 
                                            "comida" => isset($desayunos[5]['food_time']) ? strtoupper($desayunos[5]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[5]['name']) ? $desayunos[5]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[5]['image']) ? $_ENV['URL_PATH'].$desayunos[5]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[5]['id']) ? $snack1[5]['id'] : '0' , 
                                            "comida" => isset($snack1[5]['food_time']) ? strtoupper($snack1[5]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[5]['name']) ? $snack1[5]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[5]['image']) ? $_ENV['URL_PATH'].$snack1[5]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[5]['id']) ? $comidas[5]['id'] : '0' , 
                                            "comida" => isset($comidas[5]['food_time']) ? strtoupper($comidas[5]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[5]['name']) ? $comidas[5]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[5]['image']) ? $_ENV['URL_PATH'].$comidas[5]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[5]['id']) ? $snack2[5]['id'] : '0' , 
                                            "comida" => isset($snack2[5]['food_time']) ? strtoupper($snack2[5]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[5]['name']) ? $snack2[5]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[5]['image']) ? $_ENV['URL_PATH'].$snack2[5]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[5]['id']) ? $cenas[5]['id'] : '0' , 
                                            "comida" => isset($cenas[5]['food_time']) ? strtoupper($cenas[5]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[5]['name']) ? $cenas[5]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[5]['image']) ? $_ENV['URL_PATH'].$cenas[5]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom1))], 
                                    "fecha" => date("d", strtotime($dom1)) . " de " . $this->mes[date("n", strtotime($dom1))-1] . " " . date("Y", strtotime($dom1)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom1)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[6]['id']) ? $desayunos[6]['id'] : '0' , 
                                            "comida" => isset($desayunos[6]['food_time']) ? strtoupper($desayunos[6]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[6]['name']) ? $desayunos[6]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[6]['image']) ? $_ENV['URL_PATH'].$desayunos[6]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[6]['id']) ? $snack1[6]['id'] : '0' , 
                                            "comida" => isset($snack1[6]['food_time']) ? strtoupper($snack1[6]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[6]['name']) ? $snack1[6]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[6]['image']) ? $_ENV['URL_PATH'].$snack1[6]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[6]['id']) ? $comidas[6]['id'] : '0' , 
                                            "comida" => isset($comidas[6]['food_time']) ? strtoupper($comidas[6]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[6]['name']) ? $comidas[6]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[6]['image']) ? $_ENV['URL_PATH'].$comidas[6]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[6]['id']) ? $snack2[6]['id'] : '0' , 
                                            "comida" => isset($snack2[6]['food_time']) ? strtoupper($snack2[6]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[6]['name']) ? $snack2[6]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[6]['image']) ? $_ENV['URL_PATH'].$snack2[6]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[6]['id']) ? $cenas[6]['id'] : '0' , 
                                            "comida" => isset($cenas[6]['food_time']) ? strtoupper($cenas[6]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[6]['name']) ? $cenas[6]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[6]['image']) ? $_ENV['URL_PATH'].$cenas[6]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                )
                            )
                        ),
                        array( 
                            "semana" => date("d", strtotime($lun2)) . " al " . date("d", strtotime($dom2)) . " de " . $this->mes[date("n", strtotime($lun2))-1],
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun2) ) ], 
                                    "fecha" => date("d", strtotime($lun2)) . " de " . $this->mes[date("n", strtotime($lun2))-1] . " " . date("Y", strtotime($lun2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun2)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[7]['id']) ? $desayunos[7]['id'] : '0' , 
                                            "comida" => isset($desayunos[7]['food_time']) ? strtoupper($desayunos[7]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[7]['name']) ? $desayunos[7]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[7]['image']) ? $_ENV['URL_PATH'].$desayunos[7]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[7]['id']) ? $snack1[7]['id'] : '0' , 
                                            "comida" => isset($snack1[7]['food_time']) ? strtoupper($snack1[7]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[7]['name']) ? $snack1[7]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[7]['image']) ? $_ENV['URL_PATH'].$snack1[7]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[7]['id']) ? $comidas[7]['id'] : '0' , 
                                            "comida" => isset($comidas[7]['food_time']) ? strtoupper($comidas[7]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[7]['name']) ? $comidas[7]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[7]['image']) ? $_ENV['URL_PATH'].$comidas[7]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[7]['id']) ? $snack2[7]['id'] : '0' , 
                                            "comida" => isset($snack2[7]['food_time']) ? strtoupper($snack2[7]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[7]['name']) ? $snack2[7]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[7]['image']) ? $_ENV['URL_PATH'].$snack2[7]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[7]['id']) ? $cenas[7]['id'] : '0' , 
                                            "comida" => isset($cenas[7]['food_time']) ? strtoupper($cenas[7]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[7]['name']) ? $cenas[7]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[7]['image']) ? $_ENV['URL_PATH'].$cenas[7]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar2))], 
                                    "fecha" => date("d", strtotime($mar2)) . " de " . $this->mes[date("n", strtotime($mar2))-1] . " " . date("Y", strtotime($mar2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar2)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[8]['id']) ? $desayunos[8]['id'] : '0' , 
                                            "comida" => isset($desayunos[8]['food_time']) ? strtoupper($desayunos[8]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[8]['name']) ? $desayunos[8]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[8]['image']) ? $_ENV['URL_PATH'].$desayunos[8]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[8]['id']) ? $snack1[8]['id'] : '0' , 
                                            "comida" => isset($snack1[8]['food_time']) ? strtoupper($snack1[8]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[8]['name']) ? $snack1[8]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[8]['image']) ? $_ENV['URL_PATH'].$snack1[8]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[8]['id']) ? $comidas[8]['id'] : '0' , 
                                            "comida" => isset($comidas[8]['food_time']) ? strtoupper($comidas[8]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[8]['name']) ? $comidas[8]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[8]['image']) ? $_ENV['URL_PATH'].$comidas[8]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[8]['id']) ? $snack2[8]['id'] : '0' , 
                                            "comida" => isset($snack2[8]['food_time']) ? strtoupper($snack2[8]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[8]['name']) ? $snack2[8]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[8]['image']) ? $_ENV['URL_PATH'].$snack2[8]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[8]['id']) ? $cenas[8]['id'] : '0' , 
                                            "comida" => isset($cenas[8]['food_time']) ? strtoupper($cenas[8]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[8]['name']) ? $cenas[8]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[8]['image']) ? $_ENV['URL_PATH'].$cenas[8]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie2))], 
                                    "fecha" => date("d", strtotime($mie2)) . " de " . $this->mes[date("n", strtotime($mie2))-1] . " " . date("Y", strtotime($mie2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie2)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[9]['id']) ? $desayunos[9]['id'] : '0' , 
                                            "comida" => isset($desayunos[9]['food_time']) ? strtoupper($desayunos[9]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[9]['name']) ? $desayunos[9]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[9]['image']) ? $_ENV['URL_PATH'].$desayunos[9]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[9]['id']) ? $snack1[9]['id'] : '0' , 
                                            "comida" => isset($snack1[9]['food_time']) ? strtoupper($snack1[9]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[9]['name']) ? $snack1[9]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[9]['image']) ? $_ENV['URL_PATH'].$snack1[9]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[9]['id']) ? $comidas[9]['id'] : '0' , 
                                            "comida" => isset($comidas[9]['food_time']) ? strtoupper($comidas[9]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[9]['name']) ? $comidas[9]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[9]['image']) ? $_ENV['URL_PATH'].$comidas[9]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[9]['id']) ? $snack2[9]['id'] : '0' , 
                                            "comida" => isset($snack2[9]['food_time']) ? strtoupper($snack2[9]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[9]['name']) ? $snack2[9]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[9]['image']) ? $_ENV['URL_PATH'].$snack2[9]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[9]['id']) ? $cenas[9]['id'] : '0' , 
                                            "comida" => isset($cenas[9]['food_time']) ? strtoupper($cenas[9]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[9]['name']) ? $cenas[9]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[9]['image']) ? $_ENV['URL_PATH'].$cenas[9]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue2))], 
                                    "fecha" => date("d", strtotime($jue2)) . " de " . $this->mes[date("n", strtotime($jue2))-1] . " " . date("Y", strtotime($jue2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue2)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[10]['id']) ? $desayunos[10]['id'] : '0' , 
                                            "comida" => isset($desayunos[10]['food_time']) ? strtoupper($desayunos[10]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[10]['name']) ? $desayunos[10]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[10]['image']) ? $_ENV['URL_PATH'].$desayunos[10]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[10]['id']) ? $snack1[10]['id'] : '0' , 
                                            "comida" => isset($snack1[10]['food_time']) ? strtoupper($snack1[10]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[10]['name']) ? $snack1[10]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[10]['image']) ? $_ENV['URL_PATH'].$snack1[10]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[10]['id']) ? $comidas[10]['id'] : '0' , 
                                            "comida" => isset($comidas[10]['food_time']) ? strtoupper($comidas[10]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[10]['name']) ? $comidas[10]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[10]['image']) ? $_ENV['URL_PATH'].$comidas[10]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[10]['id']) ? $snack2[10]['id'] : '0' , 
                                            "comida" => isset($snack2[10]['food_time']) ? strtoupper($snack2[10]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[10]['name']) ? $snack2[10]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[10]['image']) ? $_ENV['URL_PATH'].$snack2[10]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[10]['id']) ? $cenas[10]['id'] : '0' , 
                                            "comida" => isset($cenas[10]['food_time']) ? strtoupper($cenas[10]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[10]['name']) ? $cenas[10]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[10]['image']) ? $_ENV['URL_PATH'].$cenas[10]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie2))], 
                                    "numero" => date("d", strtotime($vie2)), 
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[11]['id']) ? $desayunos[11]['id'] : '0' , 
                                            "comida" => isset($desayunos[11]['food_time']) ? strtoupper($desayunos[11]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[11]['name']) ? $desayunos[11]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[11]['image']) ? $_ENV['URL_PATH'].$desayunos[11]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[11]['id']) ? $snack1[11]['id'] : '0' , 
                                            "comida" => isset($snack1[11]['food_time']) ? strtoupper($snack1[11]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[11]['name']) ? $snack1[11]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[11]['image']) ? $_ENV['URL_PATH'].$snack1[11]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[11]['id']) ? $comidas[11]['id'] : '0' , 
                                            "comida" => isset($comidas[11]['food_time']) ? strtoupper($comidas[11]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[11]['name']) ? $comidas[11]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[11]['image']) ? $_ENV['URL_PATH'].$comidas[11]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[11]['id']) ? $snack2[11]['id'] : '0' , 
                                            "comida" => isset($snack2[11]['food_time']) ? strtoupper($snack2[11]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[11]['name']) ? $snack2[11]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[11]['image']) ? $_ENV['URL_PATH'].$snack2[11]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[11]['id']) ? $cenas[11]['id'] : '0' , 
                                            "comida" => isset($cenas[11]['food_time']) ? strtoupper($cenas[11]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[11]['name']) ? $cenas[11]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[11]['image']) ? $_ENV['URL_PATH'].$cenas[11]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab2))], 
                                    "fecha" => date("d", strtotime($sab2)) . " de " . $this->mes[date("n", strtotime($sab2))-1] . " " . date("Y", strtotime($sab2)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[12]['id']) ? $desayunos[12]['id'] : '0' , 
                                            "comida" => isset($desayunos[12]['food_time']) ? strtoupper($desayunos[12]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[12]['name']) ? $desayunos[12]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[12]['image']) ? $_ENV['URL_PATH'].$desayunos[12]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[12]['id']) ? $snack1[12]['id'] : '0' , 
                                            "comida" => isset($snack1[12]['food_time']) ? strtoupper($snack1[12]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[12]['name']) ? $snack1[12]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[12]['image']) ? $_ENV['URL_PATH'].$snack1[12]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[12]['id']) ? $comidas[12]['id'] : '0' , 
                                            "comida" => isset($comidas[12]['food_time']) ? strtoupper($comidas[12]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[12]['name']) ? $comidas[12]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[12]['image']) ? $_ENV['URL_PATH'].$comidas[12]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[12]['id']) ? $snack2[12]['id'] : '0' , 
                                            "comida" => isset($snack2[12]['food_time']) ? strtoupper($snack2[12]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[12]['name']) ? $snack2[12]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[12]['image']) ? $_ENV['URL_PATH'].$snack2[12]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[12]['id']) ? $cenas[12]['id'] : '0' , 
                                            "comida" => isset($cenas[12]['food_time']) ? strtoupper($cenas[12]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[12]['name']) ? $cenas[12]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[12]['image']) ? $_ENV['URL_PATH'].$cenas[12]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom2))], 
                                    "fecha" => date("d", strtotime($dom2)) . " de " . $this->mes[date("n", strtotime($dom2))-1] . " " . date("Y", strtotime($dom2)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom2)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[13]['id']) ? $desayunos[13]['id'] : '0' , 
                                            "comida" => isset($desayunos[13]['food_time']) ? strtoupper($desayunos[13]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[13]['name']) ? $desayunos[13]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[13]['image']) ? $_ENV['URL_PATH'].$desayunos[13]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[13]['id']) ? $snack1[13]['id'] : '0' , 
                                            "comida" => isset($snack1[13]['food_time']) ? strtoupper($snack1[13]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[13]['name']) ? $snack1[13]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[13]['image']) ? $_ENV['URL_PATH'].$snack1[13]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[13]['id']) ? $comidas[13]['id'] : '0' , 
                                            "comida" => isset($comidas[13]['food_time']) ? strtoupper($comidas[13]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[13]['name']) ? $comidas[13]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[13]['image']) ? $_ENV['URL_PATH'].$comidas[13]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[13]['id']) ? $snack2[13]['id'] : '0' , 
                                            "comida" => isset($snack2[13]['food_time']) ? strtoupper($snack2[13]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[13]['name']) ? $snack2[13]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[13]['image']) ? $_ENV['URL_PATH'].$snack2[13]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[13]['id']) ? $cenas[13]['id'] : '0' , 
                                            "comida" => isset($cenas[13]['food_time']) ? strtoupper($cenas[13]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[13]['name']) ? $cenas[13]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[13]['image']) ? $_ENV['URL_PATH'].$cenas[13]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                )
                            )
                        ),
                        array( 
                            "semana" => date("d", strtotime($lun3)) . " al " . date("d", strtotime($dom3)) . " de " . $this->mes[date("n", strtotime($lun3))-1],
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun3) ) ], 
                                    "fecha" => date("d", strtotime($lun3)) . " de " . $this->mes[date("n", strtotime($lun3))-1] . " " . date("Y", strtotime($lun3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun3)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[14]['id']) ? $desayunos[14]['id'] : '0' , 
                                            "comida" => isset($desayunos[14]['food_time']) ? strtoupper($desayunos[14]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[14]['name']) ? $desayunos[14]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[14]['image']) ? $_ENV['URL_PATH'].$desayunos[14]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[14]['id']) ? $snack1[14]['id'] : '0' , 
                                            "comida" => isset($snack1[14]['food_time']) ? strtoupper($snack1[14]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[14]['name']) ? $snack1[14]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[14]['image']) ? $_ENV['URL_PATH'].$snack1[14]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[14]['id']) ? $comidas[14]['id'] : '0' , 
                                            "comida" => isset($comidas[14]['food_time']) ? strtoupper($comidas[14]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[14]['name']) ? $comidas[14]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[14]['image']) ? $_ENV['URL_PATH'].$comidas[14]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[14]['id']) ? $snack2[14]['id'] : '0' , 
                                            "comida" => isset($snack2[14]['food_time']) ? strtoupper($snack2[14]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[14]['name']) ? $snack2[14]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[14]['image']) ? $_ENV['URL_PATH'].$snack2[14]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[14]['id']) ? $cenas[14]['id'] : '0' , 
                                            "comida" => isset($cenas[14]['food_time']) ? strtoupper($cenas[14]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[14]['name']) ? $cenas[14]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[14]['image']) ? $_ENV['URL_PATH'].$cenas[14]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar3))], 
                                    "fecha" => date("d", strtotime($mar3)) . " de " . $this->mes[date("n", strtotime($mar3))-1] . " " . date("Y", strtotime($mar3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar3)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[15]['id']) ? $desayunos[15]['id'] : '0' , 
                                            "comida" => isset($desayunos[15]['food_time']) ? strtoupper($desayunos[15]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[15]['name']) ? $desayunos[15]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[15]['image']) ? $_ENV['URL_PATH'].$desayunos[15]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[15]['id']) ? $snack1[15]['id'] : '0' , 
                                            "comida" => isset($snack1[15]['food_time']) ? strtoupper($snack1[15]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[15]['name']) ? $snack1[15]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[15]['image']) ? $_ENV['URL_PATH'].$snack1[15]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[15]['id']) ? $comidas[15]['id'] : '0' , 
                                            "comida" => isset($comidas[15]['food_time']) ? strtoupper($comidas[15]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[15]['name']) ? $comidas[15]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[15]['image']) ? $_ENV['URL_PATH'].$comidas[15]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[15]['id']) ? $snack2[15]['id'] : '0' , 
                                            "comida" => isset($snack2[15]['food_time']) ? strtoupper($snack2[15]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[15]['name']) ? $snack2[15]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[15]['image']) ? $_ENV['URL_PATH'].$snack2[15]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[15]['id']) ? $cenas[15]['id'] : '0' , 
                                            "comida" => isset($cenas[15]['food_time']) ? strtoupper($cenas[15]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[15]['name']) ? $cenas[15]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[15]['image']) ? $_ENV['URL_PATH'].$cenas[15]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie3))], 
                                    "fecha" => date("d", strtotime($mie3)) . " de " . $this->mes[date("n", strtotime($mie3))-1] . " " . date("Y", strtotime($mie3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie3)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[16]['id']) ? $desayunos[16]['id'] : '0' , 
                                            "comida" => isset($desayunos[16]['food_time']) ? strtoupper($desayunos[16]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[16]['name']) ? $desayunos[16]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[16]['image']) ? $_ENV['URL_PATH'].$desayunos[16]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[16]['id']) ? $snack1[16]['id'] : '0' , 
                                            "comida" => isset($snack1[16]['food_time']) ? strtoupper($snack1[16]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[16]['name']) ? $snack1[16]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[16]['image']) ? $_ENV['URL_PATH'].$snack1[16]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[16]['id']) ? $comidas[16]['id'] : '0' , 
                                            "comida" => isset($comidas[16]['food_time']) ? strtoupper($comidas[16]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[16]['name']) ? $comidas[16]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[16]['image']) ? $_ENV['URL_PATH'].$comidas[16]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[16]['id']) ? $snack2[16]['id'] : '0' , 
                                            "comida" => isset($snack2[16]['food_time']) ? strtoupper($snack2[16]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[16]['name']) ? $snack2[16]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[16]['image']) ? $_ENV['URL_PATH'].$snack2[16]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[16]['id']) ? $cenas[16]['id'] : '0' , 
                                            "comida" => isset($cenas[16]['food_time']) ? strtoupper($cenas[16]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[16]['name']) ? $cenas[16]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[16]['image']) ? $_ENV['URL_PATH'].$cenas[16]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue3))], 
                                    "fecha" => date("d", strtotime($jue3)) . " de " . $this->mes[date("n", strtotime($jue3))-1] . " " . date("Y", strtotime($jue3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue3)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[17]['id']) ? $desayunos[17]['id'] : '0' , 
                                            "comida" => isset($desayunos[17]['food_time']) ? strtoupper($desayunos[17]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[17]['name']) ? $desayunos[17]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[17]['image']) ? $_ENV['URL_PATH'].$desayunos[17]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[17]['id']) ? $snack1[17]['id'] : '0' , 
                                            "comida" => isset($snack1[17]['food_time']) ? strtoupper($snack1[17]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[17]['name']) ? $snack1[17]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[17]['image']) ? $_ENV['URL_PATH'].$snack1[17]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[17]['id']) ? $comidas[17]['id'] : '0' , 
                                            "comida" => isset($comidas[17]['food_time']) ? strtoupper($comidas[17]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[17]['name']) ? $comidas[17]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[17]['image']) ? $_ENV['URL_PATH'].$comidas[17]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[17]['id']) ? $snack2[17]['id'] : '0' , 
                                            "comida" => isset($snack2[17]['food_time']) ? strtoupper($snack2[17]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[17]['name']) ? $snack2[17]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[17]['image']) ? $_ENV['URL_PATH'].$snack2[17]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[17]['id']) ? $cenas[17]['id'] : '0' , 
                                            "comida" => isset($cenas[17]['food_time']) ? strtoupper($cenas[17]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[17]['name']) ? $cenas[17]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[17]['image']) ? $_ENV['URL_PATH'].$cenas[17]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie3))], 
                                    "fecha" => date("d", strtotime($vie3)) . " de " . $this->mes[date("n", strtotime($vie3))-1] . " " . date("Y", strtotime($vie3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie3)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[18]['id']) ? $desayunos[18]['id'] : '0' , 
                                            "comida" => isset($desayunos[18]['food_time']) ? strtoupper($desayunos[18]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[18]['name']) ? $desayunos[18]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[18]['image']) ? $_ENV['URL_PATH'].$desayunos[18]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[18]['id']) ? $snack1[18]['id'] : '0' , 
                                            "comida" => isset($snack1[18]['food_time']) ? strtoupper($snack1[18]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[18]['name']) ? $snack1[18]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[18]['image']) ? $_ENV['URL_PATH'].$snack1[18]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[18]['id']) ? $comidas[18]['id'] : '0' , 
                                            "comida" => isset($comidas[18]['food_time']) ? strtoupper($comidas[18]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[18]['name']) ? $comidas[18]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[18]['image']) ? $_ENV['URL_PATH'].$comidas[18]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[18]['id']) ? $snack2[18]['id'] : '0' , 
                                            "comida" => isset($snack2[18]['food_time']) ? strtoupper($snack2[18]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[18]['name']) ? $snack2[18]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[18]['image']) ? $_ENV['URL_PATH'].$snack2[18]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[18]['id']) ? $cenas[18]['id'] : '0' , 
                                            "comida" => isset($cenas[18]['food_time']) ? strtoupper($cenas[18]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[18]['name']) ? $cenas[18]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[18]['image']) ? $_ENV['URL_PATH'].$cenas[18]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab3))], 
                                    "fecha" => date("d", strtotime($sab3)) . " de " . $this->mes[date("n", strtotime($sab3))-1] . " " . date("Y", strtotime($sab3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab3)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[19]['id']) ? $desayunos[19]['id'] : '0' , 
                                            "comida" => isset($desayunos[19]['food_time']) ? strtoupper($desayunos[19]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[19]['name']) ? $desayunos[19]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[19]['image']) ? $_ENV['URL_PATH'].$desayunos[19]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[19]['id']) ? $snack1[19]['id'] : '0' , 
                                            "comida" => isset($snack1[19]['food_time']) ? strtoupper($snack1[19]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[19]['name']) ? $snack1[19]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[19]['image']) ? $_ENV['URL_PATH'].$snack1[19]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[19]['id']) ? $comidas[19]['id'] : '0' , 
                                            "comida" => isset($comidas[19]['food_time']) ? strtoupper($comidas[19]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[19]['name']) ? $comidas[19]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[19]['image']) ? $_ENV['URL_PATH'].$comidas[19]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[19]['id']) ? $snack2[19]['id'] : '0' , 
                                            "comida" => isset($snack2[19]['food_time']) ? strtoupper($snack2[19]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[19]['name']) ? $snack2[19]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[19]['image']) ? $_ENV['URL_PATH'].$snack2[19]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[19]['id']) ? $cenas[19]['id'] : '0' , 
                                            "comida" => isset($cenas[19]['food_time']) ? strtoupper($cenas[19]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[19]['name']) ? $cenas[19]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[19]['image']) ? $_ENV['URL_PATH'].$cenas[19]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom3))], 
                                    "fecha" => date("d", strtotime($dom3)) . " de " . $this->mes[date("n", strtotime($dom3))-1] . " " . date("Y", strtotime($dom3)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom3)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[20]['id']) ? $desayunos[20]['id'] : '0' , 
                                            "comida" => isset($desayunos[20]['food_time']) ? strtoupper($desayunos[20]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[20]['name']) ? $desayunos[20]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[20]['image']) ? $_ENV['URL_PATH'].$desayunos[20]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[20]['id']) ? $snack1[20]['id'] : '0' , 
                                            "comida" => isset($snack1[20]['food_time']) ? strtoupper($snack1[20]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[20]['name']) ? $snack1[20]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[20]['image']) ? $_ENV['URL_PATH'].$snack1[20]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[20]['id']) ? $comidas[20]['id'] : '0' , 
                                            "comida" => isset($comidas[20]['food_time']) ? strtoupper($comidas[20]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[20]['name']) ? $comidas[20]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[20]['image']) ? $_ENV['URL_PATH'].$comidas[20]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[20]['id']) ? $snack2[20]['id'] : '0' , 
                                            "comida" => isset($snack2[20]['food_time']) ? strtoupper($snack2[20]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[20]['name']) ? $snack2[20]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[20]['image']) ? $_ENV['URL_PATH'].$snack2[20]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[20]['id']) ? $cenas[20]['id'] : '0' , 
                                            "comida" => isset($cenas[20]['food_time']) ? strtoupper($cenas[20]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[20]['name']) ? $cenas[20]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[20]['image']) ? $_ENV['URL_PATH'].$cenas[20]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                )
                            )
                        ),
                        array( 
                            "semana" => date("d", strtotime($lun4)) . " al " . date("d", strtotime($dom4)) . " de " . $this->mes[date("n", strtotime($lun4))-1],
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun4) ) ], 
                                    "fecha" => date("d", strtotime($lun4)) . " de " . $this->mes[date("n", strtotime($lun4))-1] . " " . date("Y", strtotime($lun4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun4)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[21]['id']) ? $desayunos[21]['id'] : '0' , 
                                            "comida" => isset($desayunos[21]['food_time']) ? strtoupper($desayunos[21]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[21]['name']) ? $desayunos[21]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[21]['image']) ? $_ENV['URL_PATH'].$desayunos[21]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[21]['id']) ? $snack1[21]['id'] : '0' , 
                                            "comida" => isset($snack1[21]['food_time']) ? strtoupper($snack1[21]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[21]['name']) ? $snack1[21]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[21]['image']) ? $_ENV['URL_PATH'].$snack1[21]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[21]['id']) ? $comidas[21]['id'] : '0' , 
                                            "comida" => isset($comidas[21]['food_time']) ? strtoupper($comidas[21]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[21]['name']) ? $comidas[21]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[21]['image']) ? $_ENV['URL_PATH'].$comidas[21]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[21]['id']) ? $snack2[21]['id'] : '0' , 
                                            "comida" => isset($snack2[21]['food_time']) ? strtoupper($snack2[21]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[21]['name']) ? $snack2[21]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[21]['image']) ? $_ENV['URL_PATH'].$snack2[21]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[21]['id']) ? $cenas[21]['id'] : '0' , 
                                            "comida" => isset($cenas[21]['food_time']) ? strtoupper($cenas[21]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[21]['name']) ? $cenas[21]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[21]['image']) ? $_ENV['URL_PATH'].$cenas[21]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar4))], 
                                    "fecha" => date("d", strtotime($mar4)) . " de " . $this->mes[date("n", strtotime($mar4))-1] . " " . date("Y", strtotime($mar4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar4)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[22]['id']) ? $desayunos[22]['id'] : '0' , 
                                            "comida" => isset($desayunos[22]['food_time']) ? strtoupper($desayunos[22]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[22]['name']) ? $desayunos[22]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[22]['image']) ? $_ENV['URL_PATH'].$desayunos[22]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[22]['id']) ? $snack1[22]['id'] : '0' , 
                                            "comida" => isset($snack1[22]['food_time']) ? strtoupper($snack1[22]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[22]['name']) ? $snack1[22]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[22]['image']) ? $_ENV['URL_PATH'].$snack1[22]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[22]['id']) ? $comidas[22]['id'] : '0' , 
                                            "comida" => isset($comidas[22]['food_time']) ? strtoupper($comidas[22]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[22]['name']) ? $comidas[22]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[22]['image']) ? $_ENV['URL_PATH'].$comidas[22]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[22]['id']) ? $snack2[22]['id'] : '0' , 
                                            "comida" => isset($snack2[22]['food_time']) ? strtoupper($snack2[22]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[22]['name']) ? $snack2[22]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[22]['image']) ? $_ENV['URL_PATH'].$snack2[22]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[22]['id']) ? $cenas[22]['id'] : '0' , 
                                            "comida" => isset($cenas[22]['food_time']) ? strtoupper($cenas[22]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[22]['name']) ? $cenas[22]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[22]['image']) ? $_ENV['URL_PATH'].$cenas[22]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie4))], 
                                    "fecha" => date("d", strtotime($mie4)) . " de " . $this->mes[date("n", strtotime($mie4))-1] . " " . date("Y", strtotime($mie4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie4)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[23]['id']) ? $desayunos[23]['id'] : '0' , 
                                            "comida" => isset($desayunos[23]['food_time']) ? strtoupper($desayunos[23]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[23]['name']) ? $desayunos[23]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[23]['image']) ? $_ENV['URL_PATH'].$desayunos[23]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[23]['id']) ? $snack1[23]['id'] : '0' , 
                                            "comida" => isset($snack1[23]['food_time']) ? strtoupper($snack1[23]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[23]['name']) ? $snack1[23]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[23]['image']) ? $_ENV['URL_PATH'].$snack1[23]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[23]['id']) ? $comidas[23]['id'] : '0' , 
                                            "comida" => isset($comidas[23]['food_time']) ? strtoupper($comidas[23]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[23]['name']) ? $comidas[23]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[23]['image']) ? $_ENV['URL_PATH'].$comidas[23]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[23]['id']) ? $snack2[23]['id'] : '0' , 
                                            "comida" => isset($snack2[23]['food_time']) ? strtoupper($snack2[23]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[23]['name']) ? $snack2[23]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[23]['image']) ? $_ENV['URL_PATH'].$snack2[23]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[23]['id']) ? $cenas[23]['id'] : '0' , 
                                            "comida" => isset($cenas[23]['food_time']) ? strtoupper($cenas[23]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[23]['name']) ? $cenas[23]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[23]['image']) ? $_ENV['URL_PATH'].$cenas[23]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue4))], 
                                    "fecha" => date("d", strtotime($jue4)) . " de " . $this->mes[date("n", strtotime($jue4))-1] . " " . date("Y", strtotime($jue4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue4)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[24]['id']) ? $desayunos[24]['id'] : '0' , 
                                            "comida" => isset($desayunos[24]['food_time']) ? strtoupper($desayunos[24]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[24]['name']) ? $desayunos[24]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[24]['image']) ? $_ENV['URL_PATH'].$desayunos[24]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[24]['id']) ? $snack1[24]['id'] : '0' , 
                                            "comida" => isset($snack1[24]['food_time']) ? strtoupper($snack1[24]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[24]['name']) ? $snack1[24]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[24]['image']) ? $_ENV['URL_PATH'].$snack1[24]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[24]['id']) ? $comidas[24]['id'] : '0' , 
                                            "comida" => isset($comidas[24]['food_time']) ? strtoupper($comidas[24]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[24]['name']) ? $comidas[24]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[24]['image']) ? $_ENV['URL_PATH'].$comidas[24]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[24]['id']) ? $snack2[24]['id'] : '0' , 
                                            "comida" => isset($snack2[24]['food_time']) ? strtoupper($snack2[24]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[24]['name']) ? $snack2[24]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[24]['image']) ? $_ENV['URL_PATH'].$snack2[24]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[24]['id']) ? $cenas[24]['id'] : '0' , 
                                            "comida" => isset($cenas[24]['food_time']) ? strtoupper($cenas[24]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[24]['name']) ? $cenas[24]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[24]['image']) ? $_ENV['URL_PATH'].$cenas[24]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie4))], 
                                    "fecha" => date("d", strtotime($vie4)) . " de " . $this->mes[date("n", strtotime($vie4))-1] . " " . date("Y", strtotime($vie4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie4)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[25]['id']) ? $desayunos[25]['id'] : '0' , 
                                            "comida" => isset($desayunos[25]['food_time']) ? strtoupper($desayunos[25]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[25]['name']) ? $desayunos[25]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[25]['image']) ? $_ENV['URL_PATH'].$desayunos[25]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[25]['id']) ? $snack1[25]['id'] : '0' , 
                                            "comida" => isset($snack1[25]['food_time']) ? strtoupper($snack1[25]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[25]['name']) ? $snack1[25]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[25]['image']) ? $_ENV['URL_PATH'].$snack1[25]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[25]['id']) ? $comidas[25]['id'] : '0' , 
                                            "comida" => isset($comidas[25]['food_time']) ? strtoupper($comidas[25]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[25]['name']) ? $comidas[25]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[25]['image']) ? $_ENV['URL_PATH'].$comidas[25]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[25]['id']) ? $snack2[25]['id'] : '0' , 
                                            "comida" => isset($snack2[25]['food_time']) ? strtoupper($snack2[25]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[25]['name']) ? $snack2[25]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[25]['image']) ? $_ENV['URL_PATH'].$snack2[25]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[25]['id']) ? $cenas[25]['id'] : '0' , 
                                            "comida" => isset($cenas[25]['food_time']) ? strtoupper($cenas[25]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[25]['name']) ? $cenas[25]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[25]['image']) ? $_ENV['URL_PATH'].$cenas[25]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab4))], 
                                    "fecha" => date("d", strtotime($sab4)) . " de " . $this->mes[date("n", strtotime($sab4))-1] . " " . date("Y", strtotime($sab4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab4)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[26]['id']) ? $desayunos[26]['id'] : '0' , 
                                            "comida" => isset($desayunos[26]['food_time']) ? strtoupper($desayunos[26]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[26]['name']) ? $desayunos[26]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[26]['image']) ? $_ENV['URL_PATH'].$desayunos[26]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[26]['id']) ? $snack1[26]['id'] : '0' , 
                                            "comida" => isset($snack1[26]['food_time']) ? strtoupper($snack1[26]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[26]['name']) ? $snack1[26]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[26]['image']) ? $_ENV['URL_PATH'].$snack1[26]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[26]['id']) ? $comidas[26]['id'] : '0' , 
                                            "comida" => isset($comidas[26]['food_time']) ? strtoupper($comidas[26]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[26]['name']) ? $comidas[26]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[26]['image']) ? $_ENV['URL_PATH'].$comidas[26]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[26]['id']) ? $snack2[26]['id'] : '0' , 
                                            "comida" => isset($snack2[26]['food_time']) ? strtoupper($snack2[26]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[26]['name']) ? $snack2[26]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[26]['image']) ? $_ENV['URL_PATH'].$snack2[26]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[26]['id']) ? $cenas[26]['id'] : '0' , 
                                            "comida" => isset($cenas[26]['food_time']) ? strtoupper($cenas[26]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[26]['name']) ? $cenas[26]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[26]['image']) ? $_ENV['URL_PATH'].$cenas[26]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom4))], 
                                    "fecha" => date("d", strtotime($dom4)) . " de " . $this->mes[date("n", strtotime($dom4))-1] . " " . date("Y", strtotime($dom4)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom4)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[27]['id']) ? $desayunos[27]['id'] : '0' , 
                                            "comida" => isset($desayunos[27]['food_time']) ? strtoupper($desayunos[27]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[27]['name']) ? $desayunos[27]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[27]['image']) ? $_ENV['URL_PATH'].$desayunos[27]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[27]['id']) ? $snack1[27]['id'] : '0' , 
                                            "comida" => isset($snack1[27]['food_time']) ? strtoupper($snack1[27]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[27]['name']) ? $snack1[27]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[27]['image']) ? $_ENV['URL_PATH'].$snack1[27]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[27]['id']) ? $comidas[27]['id'] : '0' , 
                                            "comida" => isset($comidas[27]['food_time']) ? strtoupper($comidas[27]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[27]['name']) ? $comidas[27]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[27]['image']) ? $_ENV['URL_PATH'].$comidas[27]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[27]['id']) ? $snack2[27]['id'] : '0' , 
                                            "comida" => isset($snack2[27]['food_time']) ? strtoupper($snack2[27]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[27]['name']) ? $snack2[27]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[27]['image']) ? $_ENV['URL_PATH'].$snack2[27]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[27]['id']) ? $cenas[27]['id'] : '0' , 
                                            "comida" => isset($cenas[27]['food_time']) ? strtoupper($cenas[27]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[27]['name']) ? $cenas[27]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[27]['image']) ? $_ENV['URL_PATH'].$cenas[27]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                )
                            )
                        ),
                        array( 
                            "semana" => date("d", strtotime($lun5)) . " al " . date("d", strtotime($dom5)) . " de " . $this->mes[date("n", strtotime($lun5))-1],
                            "dias" => array(
                                array( 
                                    "dia" => $this->dia[ date( "w", strtotime($lun5) ) ], 
                                    "fecha" => date("d", strtotime($lun5)) . " de " . $this->mes[date("n", strtotime($lun5))-1] . " " . date("Y", strtotime($lun5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($lun5)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[28]['id']) ? $desayunos[28]['id'] : '0' , 
                                            "comida" => isset($desayunos[28]['food_time']) ? strtoupper($desayunos[28]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[28]['name']) ? $desayunos[28]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[28]['image']) ? $_ENV['URL_PATH'].$desayunos[28]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[28]['id']) ? $snack1[28]['id'] : '0' , 
                                            "comida" => isset($snack1[28]['food_time']) ? strtoupper($snack1[28]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[28]['name']) ? $snack1[28]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[28]['image']) ? $_ENV['URL_PATH'].$snack1[28]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[28]['id']) ? $comidas[28]['id'] : '0' , 
                                            "comida" => isset($comidas[28]['food_time']) ? strtoupper($comidas[28]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[28]['name']) ? $comidas[28]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[28]['image']) ? $_ENV['URL_PATH'].$comidas[28]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[28]['id']) ? $snack2[28]['id'] : '0' , 
                                            "comida" => isset($snack2[28]['food_time']) ? strtoupper($snack2[28]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[28]['name']) ? $snack2[28]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[28]['image']) ? $_ENV['URL_PATH'].$snack2[28]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[28]['id']) ? $cenas[28]['id'] : '0' , 
                                            "comida" => isset($cenas[28]['food_time']) ? strtoupper($cenas[28]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[28]['name']) ? $cenas[28]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[28]['image']) ? $_ENV['URL_PATH'].$cenas[28]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mar5))], 
                                    "fecha" => date("d", strtotime($mar5)) . " de " . $this->mes[date("n", strtotime($mar5))-1] . " " . date("Y", strtotime($mar5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mar5)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[29]['id']) ? $desayunos[29]['id'] : '0' , 
                                            "comida" => isset($desayunos[29]['food_time']) ? strtoupper($desayunos[29]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[29]['name']) ? $desayunos[29]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[29]['image']) ? $_ENV['URL_PATH'].$desayunos[29]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[29]['id']) ? $snack1[29]['id'] : '0' , 
                                            "comida" => isset($snack1[29]['food_time']) ? strtoupper($snack1[29]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[29]['name']) ? $snack1[29]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[29]['image']) ? $_ENV['URL_PATH'].$snack1[29]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[29]['id']) ? $comidas[29]['id'] : '0' , 
                                            "comida" => isset($comidas[29]['food_time']) ? strtoupper($comidas[29]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[29]['name']) ? $comidas[29]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[29]['image']) ? $_ENV['URL_PATH'].$comidas[29]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[29]['id']) ? $snack2[29]['id'] : '0' , 
                                            "comida" => isset($snack2[29]['food_time']) ? strtoupper($snack2[29]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[29]['name']) ? $snack2[29]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[29]['image']) ? $_ENV['URL_PATH'].$snack2[29]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[29]['id']) ? $cenas[29]['id'] : '0' , 
                                            "comida" => isset($cenas[29]['food_time']) ? strtoupper($cenas[29]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[29]['name']) ? $cenas[29]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[29]['image']) ? $_ENV['URL_PATH'].$cenas[29]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($mie5))], 
                                    "fecha" => date("d", strtotime($mie5)) . " de " . $this->mes[date("n", strtotime($mie5))-1] . " " . date("Y", strtotime($mie5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($mie5)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[30]['id']) ? $desayunos[30]['id'] : '0' , 
                                            "comida" => isset($desayunos[30]['food_time']) ? strtoupper($desayunos[30]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[30]['name']) ? $desayunos[30]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[30]['image']) ? $_ENV['URL_PATH'].$desayunos[30]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[30]['id']) ? $snack1[30]['id'] : '0' , 
                                            "comida" => isset($snack1[30]['food_time']) ? strtoupper($snack1[30]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[30]['name']) ? $snack1[30]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[30]['image']) ? $_ENV['URL_PATH'].$snack1[30]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[30]['id']) ? $comidas[30]['id'] : '0' , 
                                            "comida" => isset($comidas[30]['food_time']) ? strtoupper($comidas[30]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[30]['name']) ? $comidas[30]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[30]['image']) ? $_ENV['URL_PATH'].$comidas[30]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[30]['id']) ? $snack2[30]['id'] : '0' , 
                                            "comida" => isset($snack2[30]['food_time']) ? strtoupper($snack2[30]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[30]['name']) ? $snack2[30]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[30]['image']) ? $_ENV['URL_PATH'].$snack2[30]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[30]['id']) ? $cenas[30]['id'] : '0' , 
                                            "comida" => isset($cenas[30]['food_time']) ? strtoupper($cenas[30]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[30]['name']) ? $cenas[30]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[30]['image']) ? $_ENV['URL_PATH'].$cenas[30]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($jue5))], 
                                    "fecha" => date("d", strtotime($jue5)) . " de " . $this->mes[date("n", strtotime($jue5))-1] . " " . date("Y", strtotime($jue5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($jue5)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[31]['id']) ? $desayunos[31]['id'] : '0' , 
                                            "comida" => isset($desayunos[31]['food_time']) ? strtoupper($desayunos[31]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[31]['name']) ? $desayunos[31]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[31]['image']) ? $_ENV['URL_PATH'].$desayunos[31]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[31]['id']) ? $snack1[31]['id'] : '0' , 
                                            "comida" => isset($snack1[31]['food_time']) ? strtoupper($snack1[31]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[31]['name']) ? $snack1[31]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[31]['image']) ? $_ENV['URL_PATH'].$snack1[31]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[31]['id']) ? $comidas[31]['id'] : '0' , 
                                            "comida" => isset($comidas[31]['food_time']) ? strtoupper($comidas[31]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[31]['name']) ? $comidas[31]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[31]['image']) ? $_ENV['URL_PATH'].$comidas[31]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[31]['id']) ? $snack2[31]['id'] : '0' , 
                                            "comida" => isset($snack2[31]['food_time']) ? strtoupper($snack2[31]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[31]['name']) ? $snack2[31]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[31]['image']) ? $_ENV['URL_PATH'].$snack2[31]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[31]['id']) ? $cenas[31]['id'] : '0' , 
                                            "comida" => isset($cenas[31]['food_time']) ? strtoupper($cenas[31]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[31]['name']) ? $cenas[31]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[31]['image']) ? $_ENV['URL_PATH'].$cenas[31]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($vie5))], 
                                    "numero" => date("d", strtotime($vie5)), 
                                    "fecha" => date("d", strtotime($vie5)) . " de " . $this->mes[date("n", strtotime($vie5))-1] . " " . date("Y", strtotime($vie5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($vie5)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[32]['id']) ? $desayunos[32]['id'] : '0' , 
                                            "comida" => isset($desayunos[32]['food_time']) ? strtoupper($desayunos[32]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[32]['name']) ? $desayunos[32]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[32]['image']) ? $_ENV['URL_PATH'].$desayunos[32]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[32]['id']) ? $snack1[32]['id'] : '0' , 
                                            "comida" => isset($snack1[32]['food_time']) ? strtoupper($snack1[32]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[32]['name']) ? $snack1[32]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[32]['image']) ? $_ENV['URL_PATH'].$snack1[32]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[32]['id']) ? $comidas[32]['id'] : '0' , 
                                            "comida" => isset($comidas[32]['food_time']) ? strtoupper($comidas[32]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[32]['name']) ? $comidas[32]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[32]['image']) ? $_ENV['URL_PATH'].$comidas[32]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[32]['id']) ? $snack2[32]['id'] : '0' , 
                                            "comida" => isset($snack2[32]['food_time']) ? strtoupper($snack2[32]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[32]['name']) ? $snack2[32]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[32]['image']) ? $_ENV['URL_PATH'].$snack2[32]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[32]['id']) ? $cenas[32]['id'] : '0' , 
                                            "comida" => isset($cenas[32]['food_time']) ? strtoupper($cenas[32]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[32]['name']) ? $cenas[32]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[32]['image']) ? $_ENV['URL_PATH'].$cenas[32]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($sab5))], 
                                    "fecha" => date("d", strtotime($sab5)) . " de " . $this->mes[date("n", strtotime($sab5))-1] . " " . date("Y", strtotime($sab5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($sab5)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[33]['id']) ? $desayunos[33]['id'] : '0' , 
                                            "comida" => isset($desayunos[33]['food_time']) ? strtoupper($desayunos[33]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[33]['name']) ? $desayunos[33]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[33]['image']) ? $_ENV['URL_PATH'].$desayunos[33]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[33]['id']) ? $snack1[33]['id'] : '0' , 
                                            "comida" => isset($snack1[33]['food_time']) ? strtoupper($snack1[33]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[33]['name']) ? $snack1[33]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[33]['image']) ? $_ENV['URL_PATH'].$snack1[33]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[33]['id']) ? $comidas[33]['id'] : '0' , 
                                            "comida" => isset($comidas[33]['food_time']) ? strtoupper($comidas[33]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[33]['name']) ? $comidas[33]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[33]['image']) ? $_ENV['URL_PATH'].$comidas[33]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[33]['id']) ? $snack2[33]['id'] : '0' , 
                                            "comida" => isset($snack2[33]['food_time']) ? strtoupper($snack2[33]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[33]['name']) ? $snack2[33]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[33]['image']) ? $_ENV['URL_PATH'].$snack2[33]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[33]['id']) ? $cenas[33]['id'] : '0' , 
                                            "comida" => isset($cenas[33]['food_time']) ? strtoupper($cenas[33]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[33]['name']) ? $cenas[33]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[33]['image']) ? $_ENV['URL_PATH'].$cenas[33]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                ),
                                array( 
                                    "dia" => $this->dia[date("w", strtotime($dom5))], 
                                    "fecha" => date("d", strtotime($dom5)) . " de " . $this->mes[date("n", strtotime($dom5))-1] . " " . date("Y", strtotime($dom5)),
                                    "fecha_formato" => date("d-m-Y", strtotime($dom5)),
                                    "comidas" => array(
                                        "alimento1" => array( 
                                            "id" => isset($desayunos[34]['id']) ? $desayunos[34]['id'] : '0' , 
                                            "comida" => isset($desayunos[34]['food_time']) ? strtoupper($desayunos[34]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($desayunos[34]['name']) ? $desayunos[34]['name'] : "Sin Datos", 
                                            "image" => isset($desayunos[34]['image']) ? $_ENV['URL_PATH'].$desayunos[34]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento2" => array( 
                                            "id" => isset($snack1[34]['id']) ? $snack1[34]['id'] : '0' , 
                                            "comida" => isset($snack1[34]['food_time']) ? strtoupper($snack1[34]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack1[34]['name']) ? $snack1[34]['name'] : "Sin Datos", 
                                            "image" => isset($snack1[34]['image']) ? $_ENV['URL_PATH'].$snack1[34]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento3" => array( 
                                            "id" => isset($comidas[34]['id']) ? $comidas[34]['id'] : '0' , 
                                            "comida" => isset($comidas[34]['food_time']) ? strtoupper($comidas[34]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($comidas[34]['name']) ? $comidas[34]['name'] : "Sin Datos", 
                                            "image" => isset($comidas[34]['image']) ? $_ENV['URL_PATH'].$comidas[34]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento4" => array( 
                                            "id" => isset($snack2[34]['id']) ? $snack2[34]['id'] : '0' , 
                                            "comida" => isset($snack2[34]['food_time']) ? strtoupper($snack2[34]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($snack2[34]['name']) ? $snack2[34]['name'] : "Sin Datos", 
                                            "image" => isset($snack2[34]['image']) ? $_ENV['URL_PATH'].$snack2[34]['image'] : "Sin Imagen", 
                                        ),
                                        "alimento5" => array( 
                                            "id" => isset($cenas[34]['id']) ? $cenas[34]['id'] : '0' , 
                                            "comida" => isset($cenas[34]['food_time']) ? strtoupper($cenas[34]['food_time']) : "Sin Datos", 
                                            "nombre" => isset($cenas[34]['name']) ? $cenas[34]['name'] : "Sin Datos", 
                                            "image" => isset($cenas[34]['image']) ? $_ENV['URL_PATH'].$cenas[34]['image'] : "Sin Imagen", 
                                        ),
                                    )
                                )
                            )
                        ),
                    );

                    $PlanSemanalControl = new PlanSemanalControl();
                    $PlanSemanalControl->i_client = $r->id;
                    $PlanSemanalControl->json = json_encode($result);
                    $PlanSemanalControl->expire_at = $dom5;
                    $PlanSemanalControl->save();
                } else {
                    $result = json_decode($PlanSemanalControl['json']);
                }
                */

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $result
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function imprimirPlan ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $PlanSemanalControl = PlanSemanalControl::select("json")->where("i_client", $r->cliente)->orderBy("id", "DESC")->first()->toArray();
                $toArray = json_decode($PlanSemanalControl['json'], true); 
                $salida = array(); 
                foreach ( $toArray[$r->posicion]['dias'] as $item ) {
                    array_push ( $salida,  array( $item['dia'], substr($item['fecha'], 0, -5), $item['comidas']['alimento1']['nombre'], $item['comidas']['alimento2']['nombre'], $item['comidas']['alimento3']['nombre'], $item['comidas']['alimento4']['nombre'], $item['comidas']['alimento5']['nombre'] ) );
                }
                $pdf = PDF::loadView('menu.print', compact('salida'));
                $path = '/pdf/menu/' . md5("menu_{$r->cliente}") . time() .'.pdf';
                $pdf->save( $_SERVER['DOCUMENT_ROOT'] . $path );

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $_ENV['URL_PATH'] . $path
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function reprocessShoppingList ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            $clientes = Clients::select('nutrition_plan')->where('id', $r->cliente)->first();
            $generalData = GeneralData::select('calories')->where('i_client', $r->cliente)->first();
            $PlanSemanalControl = PlanSemanalControl::where("i_client", $r->cliente)->first()->toArray();
            $result = json_decode($PlanSemanalControl['json'], true);

            ShoppingListDates::where("i_client", $r->cliente)->delete();
            foreach ( $result as $key => $itemSemana ) {
                if ( $key == 0 || $key == 1 || $key == 2 || $key == 3 || $key == 4 ) {
                    foreach ( $itemSemana['dias'] as $item ) {

                        $ShoppingListDates = new ShoppingListDates();
                        $ShoppingListDates->i_client = $r->cliente;
                        $ShoppingListDates->date_at = date("Y-m-d", strtotime($item["fecha_formato"]));
                        $ShoppingListDates->save();

                        foreach ( $item['comidas'] as $itemFood ) {
                            if ( $itemFood["id"] != 0 ){
                                $programaReceta = ProgramRecipts::select("id")->where("i_recipt", $itemFood['id'])->where("i_program", $clientes['nutrition_plan'])->first();

                                if ( $itemFood['comida'] == "SNACK" ){
                                    $generalDataCalories = 1100;
                                } else {
                                    $generalDataCalories = $generalData['calories'];
                                }

                                if ( $generalData['calories'] < 1100 ) {
                                    $generalDataCalories = 1100;
                                } elseif ( $generalData['calories'] == 2100 ) {
                                    $generalDataCalories = 2000;
                                }

                                $calorieRecipts = CalorieRecipts::select("id")->where("i_program", $programaReceta['id'])->where("i_calorie", $generalDataCalories)->first();
                                
                                $ingredientRecipts = IngredientRecipts::select("i_ingredient", "portion")->where("i_calorie", $calorieRecipts['id'])->get()->toArray();

                                foreach ( $ingredientRecipts as $itemIngredient ) {
                                    $ingredients = Ingredients::select("name", "portion", "unit")->where("id", $itemIngredient["i_ingredient"])->first();

                                    $ShoppingList = new ShoppingList();
                                    $ShoppingList->i_shopping_date = $ShoppingListDates->id;
                                    $ShoppingList->item = $itemIngredient["i_ingredient"];
                                    $ShoppingList->item_name = $ingredients["name"];
                                    $ShoppingList->quantity = $this->dec2frac($itemIngredient["portion"] * $ingredients["portion"], $ingredients["unit"]);
                                    $ShoppingList->i_unit = $ingredients["unit"];
                                    $ShoppingList->save();
                                }
                            }
                        }   
                    }
                }
            }
        }
    }
}
